.model  tiny
.code
org     100h
main:   mov  ax,0201h         ; Int 13h 'n 2.fonksiyonu=okuma,1 sektr.
        mov  bx,offset buffer ; es:bx=bilginin tanaca buffer adresi.
        mov  cx,0001h         ; 0.track,1.sector=boot sector.
        mov  dx,0000h         ; 0.yz,0.src=a:
        int  13h              ;
        cmp  ah,0             ; hata kodu=0 ise hataYok
        jz   hataYok          ;
        cmp  ah,06h           ; disket deiiklii nedeni ile okunamyorsa
        jz   Dene             ; tekrar dene..
        mov  ah,4ch           ; program bitir.
        int  21h
HataYok:mov  si,offset buffer+0bh
        mov  di,offset dInfo  ; Oem Id 'den sonraki disket
        mov  cx,52            ; parametrelerini yeni boot programna
        rep  movsb            ; kopyala.
        mov  ax,0301          ; Int 13h 'n 2.fonksiyonu=yazma,1 sektr.
        mov  bx,offset BootPr ; es:bx=yazlacak bilginin buffer adresi.
        mov  cx,0001h         ; 0.track,1.sector=boot sector.
        mov  dx,0000h         ; 0.yz,0.src=a:
        int  13h              ;
        mov  ah,4ch
        int  21h
Dene:   mov  ax,0201h         ; Int 13h 'n 2.fonksiyonu=okuma,1 sektr.
        mov  bx,offset buffer ; es:bx=bilginin tanaca buffer adresi.
        mov  cx,0001h         ; 0.track,1.sector=boot sector.
        mov  dx,0000h         ; 0.yz,0.src=a:
        int  13h              ;
        cmp  ah,0
        jz   HataYok
        mov  ah,4ch
        int  21h
Buffer  db   512 dup(0)

BootBeg label Word
BootPr  proc near
        jmp  short Bbegin
        db   90h
        db   'PCW - Ps'       ; Oem Id
dInfo   db   52 dup(0)        ; Disket parametreleri.
bBegin: mov  si,mesaj
        push cs
        pop  ds
        call yaz              ; Mesaj yazdr.
        xor  ax,ax            ; Tu bekle.
        int  16h
        int  19h              ; Resetle.
yaz:    lodsb
        cmp  al,0
        jz   yBitti
        mov  ah,0eh
        xor  bh,bh
        int  10h
        jmp  yaz
yBitti: ret

Mesaj   equ ( $ - BootBeg ) + 7c00h
        db   13,10,'PC World/Trkiye < Programlama Sanat >'
        db   13,10,'rnek program no : 1'
        db   13,10,'Bu bir sistem disketi deildir.'
        db   13,10,'Ltfen bir sistem disketi takp bir tua basnz.'
        db   13,10,13,10,9,9,' Semih Hazar ',9,9,13,10,0
        db   512 - 2 - ( $ - BootBeg ) dup (0)
        db   055h,0aah        ; Boot Sektrn bittiini belirten word.
BootPr  endp
end     main