uses crt,graph,dos,dcpunit;
var
 Gd,Gm          : integer;
 Drive          : byte;
 tmpStr         : string;
 i,j            : word;
 kapasite       : longint;
 Dosya          : file;
 sector         : byte;
 Img            : Pointer;
 palette        : array[1..768] of byte;
 regs           : registers;
 info           : searchrec;
 BgiPath        : Pathstr;
 boot           : array[1..512] of byte;
 imsize         : word;
 size           : word;
 p              : pointer;
 x              : byte;

Procedure SpGrp; External;
{$L DCopy.OBJ}

Function ExitProg:Boolean;
Var
 Sec            : char;

begin
 imsize:=imagesize(90,80,232,137);
 getmem(p,imsize);
 getimage(90,80,232,137,p^);
 sound(300);delay(50);nosound;
 sound(500);delay(50);nosound;
 img:=@Exi;
 putimage(90,80,img^,normalput);
 Sec:=Readkey;
 If (sec='y') or (sec='Y') or (sec=#13) then ExitProg:=True;
 If (sec='n') or (sec='N') or (sec=#27) then ExitProg:=False;
 putimage(90,80,P^,normalput);
 freemem(p,imsize);
End;

Procedure Error(durum:byte);
begin
 clrscr;
 textcolor(11);
 writeln('       Disk Copier v2.0   Copyright (c) 1994 ,  A.Serdar HAZAR');
 textcolor(14);
 writeln('          Prizma      Turkish Amateur Programmers'' Group');
 writeln;textcolor(13);
 case durum of
  1:begin
     writeln('  Usage   : DCopy [Drive]');
     writeln('  Example : DCopy A:');
    end;
  2:writeln(' Error : Insufficent Disk Space on Drive C:');
  3:writeln(' Error : Invalid Drive.');
  4:writeln(' Error : Drive not ready.');
end;
halt(1);
end;

Procedure BgiError;
var
 f      : file;
 tstr   : string;

begin
 tstr:='';
 clrscr;
 textcolor(11);
 writeln('       Disk Copier v2.0   Copyright (c) 1994 ,  A.Serdar HAZAR');
 textcolor(14);
 writeln('          Prizma      Turkish Amateur Programmers'' Group');
 writeln;textcolor(13);
 writeln('File not found : SVga256.Bgi');
 textcolor(12);
 writeln('Please Enter the Full Path of the Graphics Driver or Press < to Exit :');
 textcolor(7);
 readln(BgiPath);
 if BgiPath='' then
 begin
  textcolor(7);
  halt(1);
 end else
 begin
  if ((bgipath[1]='\') and (length(bgipath)=1)) or ((bgipath[3]='\') and (length(bgipath)=3))
  then tstr:=BgiPath+'SVga256.Bgi'else tstr:=BgiPath+'\SVga256.Bgi';
  assign(f,tstr);
  {$I-} reset(f); {$I+}
  if IOResult<>0 then bgiError;
 end;
end;

procedure Kopyala;
var
 regs           : registers;
 TrackNo        : byte;
 Buffer         : array[1..9216] of byte;
 key            : char;
 don            : byte;

label dongu,dongu1,dongu2,dongu3,dongu4,Bitis;
begin
dongu:
 imsize:=imagesize(90,80,232,137);
 getmem(p,imsize);
 getimage(90,80,232,137,p^);
 sound(300);delay(50);nosound;
 sound(500);delay(50);nosound;
 img:=@sour;
 putimage(90,80,img^,normalput);
 assign(Dosya,'c:\Prizma.Tmp');
 rewrite(Dosya,1);
 key:=readkey;
 putimage(90,80,P^,normalput);
 freemem(p,imsize);
 if (key=#27) and (ExitProg) then goto Bitis;
 kapasite:=0;kapasite:=disksize(drive+1);
 if disksize(3)<kapasite then
 begin
  closegraph;
  error(2);
 end;
 if kapasite=-1 then goto dongu;
 {        BOOT       }
 regs.ah:=02;
 regs.dl:=drive;
 regs.cl:=1;
 regs.al:=1;
 regs.ch:=0;
 regs.dh:=0;
 regs.es:=seg(boot[1]);
 regs.bx:=ofs(boot[1]);
 intr($13,regs);
 setcolor(47);
 settextstyle(2,0,0);
 for i:=4 to 11 do outtextxy(17+((i-4)*6),140,chr(boot[i]));
 for i:=44 to 54 do outtextxy(13+((i-44)*6),170,chr(boot[i]));
 sector:=boot[$19];
 {    END          }
 setcolor(14);
 TrackNo:=0;
 if sector=9 then size:=9*512 else size:=9216;
 for i:=119 to 198 do
 begin
dongu2:
  regs.ah:=02;
  regs.dl:=drive;
  regs.cl:=1;
  regs.al:=Sector;
  regs.ch:=TrackNo;
  regs.dh:=0;
  regs.es:=seg(buffer[1]);
  regs.bx:=ofs(buffer[1]);
  intr($13,regs);
  if regs.ah=6 then goto dongu2;
  blockwrite(dosya,buffer[1],size);
  inc(TrackNo);
  line(i,142,i,151);
  if keypressed then
  begin
   if (readkey=#27) and (ExitProg) then goto Bitis;
  end;
 end;
 trackno:=0;
 for i:=119 to 198 do
 begin
  regs.ah:=02;
  regs.dl:=drive;
  regs.cl:=1;
  regs.al:=Sector;
  regs.ch:=TrackNo;
  regs.dh:=1;
  regs.es:=seg(buffer[1]);
  regs.bx:=ofs(buffer[1]);
  intr($13,regs);
  blockwrite(dosya,buffer[1],size);
  inc(TrackNo);
  line(i,170,i,179);
  if keypressed then
  begin
   if (readkey=#27) and (ExitProg) then goto Bitis;
  end;
 end;
 close(dosya);

 don:=0;
 assign(dosya,'c:\Prizma.Tmp');
 Reset(dosya,1);
dongu1:
  imsize:=imagesize(90,80,232,137);
  getmem(p,imsize);
  getimage(90,80,232,137,p^);
  sound(300);delay(50);nosound;
  sound(500);delay(50);nosound;
  img:=@targe;
  putimage(90,80,img^,normalput);
  key:=readkey;
  putimage(90,80,P^,normalput);
  freemem(p,imsize);
  if (key=#27) and (ExitProg) then goto Bitis;
  kapasite:=0;kapasite:=disksize(drive+1);
 if kapasite=-1 then goto dongu1;
 if don=0 then
 begin
  seek(dosya,0);
  setcolor(4);
  don:=1;
 end else
 begin
  setcolor(207);
  don:=0;
  seek(dosya,0);
 end;
 trackno:=0;
 for i:=119 to 198 do
 begin
  blockread(dosya,buffer[1],size);
dongu3:
  regs.ah:=03;
  regs.dl:=drive;
  regs.cl:=1;
  regs.al:=Sector;
  regs.ch:=TrackNo;
  regs.dh:=0;
  regs.es:=seg(buffer[1]);
  regs.bx:=ofs(buffer[1]);
  intr($13,regs);
  if regs.ah=3 then
  begin
   imsize:=imagesize(90,80,232,137);
   getmem(p,imsize);
   getimage(90,80,232,137,p^);
   sound(300);delay(50);nosound;
   sound(500);delay(50);nosound;
   img:=@Protec;
   putimage(90,80,img^,normalput);
   key:=readkey;
   putimage(90,80,P^,normalput);
   freemem(p,imsize);
   goto dongu3;
  end;
  if regs.ah=6 then goto dongu3;
  inc(TrackNo);
  line(i,142,i,151);
  if keypressed then
  begin
   if (readkey=#27) and (ExitProg) then goto Bitis;
  end;
 end;
 trackno:=0;
 for i:=119 to 198 do
 begin
dongu4:
  blockread(dosya,buffer[1],size);
  regs.ah:=03;
  regs.dl:=drive;
  regs.cl:=1;
  regs.al:=Sector;
  regs.ch:=TrackNo;
  regs.dh:=1;
  regs.es:=seg(buffer[1]);
  regs.bx:=ofs(buffer[1]);
  intr($13,regs);
  if regs.ah=6 then goto dongu4;
  inc(TrackNo);
  line(i,170,i,179);
  if keypressed then
  begin
   if (readkey=#27) and (ExitProg) then goto Bitis;
  end;
 end;
 imsize:=imagesize(90,80,232,137);
 getmem(p,imsize);
 getimage(90,80,232,137,p^);
 sound(300);delay(50);nosound;
 sound(500);delay(50);nosound;
 img:=@anot;
 putimage(90,80,img^,normalput);
 key:=readkey;
 if upcase(key)='Y' then
 begin
  putimage(90,80,P^,normalput);
  freemem(p,imsize);
  goto dongu1;
 end else
 if upcase(key)='N' then
 begin
  putimage(90,80,P^,normalput);
  freemem(p,imsize);
  goto bitis;
 end else
 if (key=#27) and (ExitProg) then
 begin
  putimage(90,80,P^,normalput);
  freemem(p,imsize);
  goto Bitis;
 end else
 begin
  putimage(90,80,P^,normalput);
  freemem(p,imsize);
  goto Bitis;
 end;
Bitis:
 reset(dosya);
 close(dosya);
 erase(dosya);
end;

begin
 if (paramcount=0) or (paramcount>1) then error(1);
 tmpStr:=paramstr(1);
 if (length(tmpstr)<>2) or (tmpstr[2]<>':') then Error(1);
 Drive:=ord(upcase(tmpStr[1]))-65;
 if drive+1>=3 then error(3);
 BgiPath:='';
 findfirst('SVga256.Bgi',anyfile,info);
 if doserror<>0 then BgiError;
 Gd:=Installuserdriver('SVga256',nil);
 Gm:=0;
 initgraph(Gd,Gm,BgiPath);
 RegisterBgiFont(@littchr);
 for i:=1 to 786 do palette[i]:=0;
 regs.ax:=$1012;
 regs.bx:=0;
 regs.cx:=256;
 regs.dx:=ofs(palette[1]);
 regs.es:=seg(palette[1]);
 intr($10,regs);
 Img:=@spgrp;
 PutImage(0,6,Img^,NormalPut);
 for x:=0 to 20 do
 begin
  for i:=1 to $300 do palette[i]:=trunc(palet[i]*x/20);
  regs.ax:=$1012;
  regs.bx:=0;
  regs.cx:=256;
  regs.es:=seg(palette[1]);
  regs.dx:=ofs(palette[1]);
  intr($10,regs);
 end;
 Kopyala;
 for x:=20 downto 0 do
 begin
  for i:=1 to $300  do palette[i]:=trunc(palet[i]*x/20);
  regs.ax:=$1012;
  regs.bx:=0;
  regs.cx:=256;
  regs.es:=seg(palette[1]);
  regs.dx:=ofs(palette[1]);
  intr($10,regs);
 end;
 closegraph;
 gotoxy(1,25);
 writeln('                                  Prizma  ');
 writeln('                     Turkish Amateur Programmers'' Group');
 writeln('                         Disk Copier v2.0   (c) 1994');
 writeln('                           Coded by A.Serdar HAZAR');
 writeln('                          Call us, we are waiting...');
end.
