       IDENTIFICATION DIVISION.
       PROGRAM-ID.    LIGFIKSG.
       SECURITY.      Lig Fikstr Girii.
       AUTHOR.        Serkan Uzuner - Eyll'92.
       ENVIRONMENT    DIVISION.
       INPUT-OUTPUT   SECTION.
       FILE-CONTROL.
           COPY LIGFIKS.FLC.
           COPY LIGTAKIM.FLC.
           COPY LIGPARAM.FLC.
       DATA DIVISION.
       FILE SECTION.
           COPY LIGFIKS.LIB.
           COPY LIGTAKIM.LIB.  
           COPY LIGPARAM.LIB.  
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       WORKING-STORAGE SECTION.
       77 EKR-HAFTA-NO   PIC 9(2)  VALUE ZEROS.
       77 EKR-MAC-NO     PIC 9(5)  VALUE ZEROS.
       77 EKR-TAKIM1     PIC 9(2)  VALUE ZEROS.
       77 EKR-TAKIM2     PIC 9(2)  VALUE ZEROS.
       77 ENSON-MAC-NO   PIC 9(2)  VALUE ZEROS.
       77 ENSON-HAFTA-NO PIC 9(2)  VALUE ZEROS.
       77 KONT-TAKIM-NO  PIC Z(2)  VALUE ZEROS.
       77 EKR-TAKIM-ADI1 PIC X(20) VALUE SPACES.
       77 EKR-TAKIM-ADI2 PIC X(20) VALUE SPACES.
       77 KARAR          PIC 9     VALUE 0.
       77 SATIR          PIC 99    VALUE 0.
       77 INDIS          PIC 99    VALUE 0.
       77 SW-WRITE       PIC 9     VALUE 0.
       01 BUGUNUN-TARIHI.
           02 BU-YIL PIC 99. 02 BU-AY PIC 99. 02 BU-GUN PIC 99.
       01 ESCKOD PIC 99.
           88 ASAGI VALUE 00. 88 ESC    VALUE 01. 88 F1 VALUE 02.
           88 F2    VALUE 03. 88 F3     VALUE 04. 88 F8 VALUE 09.
           88 F10   VALUE 11. 88 YUKARI VALUE 99.
       77 LIGDOS-DURUMU PIC XX VALUE SPACES.
       01 TAKIM-DIZISI.
           02 TAKIM-DIZI-DATA     OCCURS 18 TIMES.
               03 TAKIM-DIZI-NO   PIC Z(2)  VALUE ZEROS.
               03 TAKIM-DIZI-ADI  PIC X(20) VALUE SPACES.
       01 SW-DIZISI.
           02 SW-DIZI-DATA        OCCURS 18 TIMES.
               03 SW-DIZI-SW      PIC X     VALUE SPACES.
      *> Tablo Deikenleri.
       01 SECIM-DIZISI.
           02 SECIM-DIZI-DATA     OCCURS 18 TIMES.
               03 SECIM-DIZI-NO   PIC Z(2)  VALUE ZEROS.
               03 SECIM-DIZI-ADI  PIC X(20) VALUE SPACES.
               03 SECIM-DIZI-SW   PIC X     VALUE SPACES.
       77 TAB-LIN        PIC 99   VALUE 0.
       77 TAB-SAY        PIC 99   VALUE 0.
       77 TAB-SECIM      PIC 99   VALUE 1.
       77 TAB-ESSEC      PIC 99   VALUE 1.
       77 TAB-INTX       PIC 9    COMP-0 VALUE 0.
       01 TAB-DEG        PIC 9(4) VALUE 0.
           88 TAB-ESC    VALUE 6912. 88 TAB-ENTER  VALUE 3328.
           88 TAB-ASAGI  VALUE 0480. 88 TAB-YUKARI VALUE 8432.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       SCREEN SECTION.
       01 HAFTA-BILGILERI.
           02 LINE 06 COLUMN 42 PIC Z(2) USING EKR-HAFTA-NO.
       01 MAC-BILGILERI REVERSE-VIDEO.
           02 MAC-NO-AL.
              03 LINE 20 COLUMN 15 PIC BZZ USING EKR-MAC-NO.
           02 MAC-TAKIM-AL1.
              03 LINE 20 COLUMN 19 PIC ZZ USING EKR-TAKIM1.
              03         COLUMN 22 PIC X(20) FROM EKR-TAKIM-ADI1.
           02 MAC-TAKIM-AL2.
              03 LINE 20 COLUMN 43 PIC ZZ USING EKR-TAKIM2.
              03         COLUMN 46 PIC X(20) FROM EKR-TAKIM-ADI2.
       01 MAC-DETAY-BILGISI.
           02 LINE SATIR COLUMN 15 PIC BZZ   FROM EKR-MAC-NO.
           02            COLUMN 19 PIC ZZ    FROM EKR-TAKIM1.
           02            COLUMN 22 PIC X(20) FROM EKR-TAKIM-ADI1.
           02            COLUMN 43 PIC ZZ    FROM EKR-TAKIM2.
           02            COLUMN 46 PIC X(20) FROM EKR-TAKIM-ADI2.
       01 MAC-DETAY-BILGISI-BOS.
           02 LINE SATIR COLUMN 15 "   ".
           02            COLUMN 19 "  ".
           02            COLUMN 22 "                    ".
           02            COLUMN 43 "  ".
           02            COLUMN 46 "                    ".
       01 FIKSTUR-ISLEMLERI REVERSE-VIDEO.
           02 LINE 1 COLUMN 26 " F  K S T  R     L E M L E R  ".
      * Takm Tablosunda Ik Kontrolleri.
       01 NORMAL-TAKIM-YAZ.
           02 LINE TAB-LIN COLUMN 53 PIC BZZB    
                                     FROM SECIM-DIZI-NO (TAB-ESSEC).
           02              COLUMN 58 PIC BX(20)B 
                                     FROM SECIM-DIZI-ADI(TAB-ESSEC).
       01 PARLAK-TAKIM-YAZ REVERSE-VIDEO.
           02 LINE TAB-LIN COLUMN 53 PIC BZZB    
                                     FROM SECIM-DIZI-NO (TAB-SECIM).
           02              COLUMN 58 PIC BX(20)B 
                                     FROM SECIM-DIZI-ADI(TAB-SECIM).
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       PROCEDURE DIVISION.
       BASLA.
           DISPLAY (1,1) ERASE.
           DISPLAY '~C=ALL/'.
           DISPLAY '~L=LIGMENU/'.
           DISPLAY '~W=LIGFIKSG,NOWAIT/'.
           PERFORM TAKIM-ADLARI-AL THRU TAKIM-ADLARI-SON.
           OPEN INPUT FIKSDOS.
           DISPLAY FIKSTUR-ISLEMLERI.
           PERFORM LIG-VE-TARIHI-YAZ. PERFORM SIFIRLA.
           DISPLAY HAFTA-BILGILERI MAC-BILGILERI.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * *         Hafta No Okuma ve Dosyadan Kontrol Etme             * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       HAFTA-NO-OKU.
           ACCEPT HAFTA-BILGILERI. PERFORM ESC-AL.
           IF ESC GO PROGRAM-SONU.
           IF F1 PERFORM OTOMATIK-HAFTA-NO THRU OTO-HAFTA-SON 
                 GO HAFTA-NO-OKU.
           IF F2 GO SONRAKI-KAYIT.
           IF F3 GO ONCEKI-KAYIT.
           IF EKR-HAFTA-NO=ZEROS OR NOT ASAGI GO HAFTA-NO-OKU.
           DISPLAY MAC-BILGILERI.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * *                     Haftay Yazdrma                        * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       HAFTA-START.
           PERFORM SAYFA-TEMIZLE VARYING SATIR FROM 10 BY 1
                                   UNTIL SATIR>18.
           MOVE SPACES TO SW-DIZISI. MOVE 10 TO SATIR.
           MOVE EKR-HAFTA-NO TO FIKS-HAFTA-NO.
           MOVE ZEROS        TO FIKS-MAC-NO.
           START FIKSDOS KEY NOT LESS THAN FIKS-KEY
                            INVALID GO SATIR-BILGILERI.
       EKRAN-KAYIT-OKU.
           READ FIKSDOS NEXT AT END GO SATIR-BILGILERI.
           IF EKR-HAFTA-NO NOT=FIKS-HAFTA-NO GO SATIR-BILGILERI.
           PERFORM EKRAN-DETAY-YAZ. ADD 1 TO SATIR.
           IF SATIR=20 GO SATIR-BILGILERI ELSE GO EKRAN-KAYIT-OKU.
       EKRAN-DETAY-YAZ.
           PERFORM SATIR-ATA.
           MOVE FIKS-MAC-NO TO EKR-MAC-NO.
           MOVE TAKIM-DIZI-ADI (EKR-TAKIM1) TO EKR-TAKIM-ADI1.
           MOVE TAKIM-DIZI-ADI (EKR-TAKIM2) TO EKR-TAKIM-ADI2.
           DISPLAY MAC-DETAY-BILGISI.
           MOVE "X" TO SW-DIZI-SW (FIKS-TAKIM1)
                       SW-DIZI-SW (FIKS-TAKIM2).
       SAYFA-TEMIZLE.
           DISPLAY MAC-DETAY-BILGISI-BOS.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * *                     Ma Kayt lemleri                     * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       SATIR-BILGILERI.
           PERFORM OTOMATIK-MAC-NO THRU OTO-MAC-SON.
           PERFORM SIFIRLA. DISPLAY MAC-BILGILERI.
       MAC-NO-OKU.
           ACCEPT MAC-NO-AL. PERFORM ESC-AL. IF ESC GO HAFTA-NO-OKU.
           IF EKR-MAC-NO=ZEROS OR >9 OR NOT ASAGI GO MAC-NO-OKU.
       MAC-KONTROL.
           MOVE EKR-HAFTA-NO TO FIKS-HAFTA-NO.
           MOVE EKR-MAC-NO   TO FIKS-MAC-NO.
           READ FIKSDOS INVALID MOVE 0 TO SW-WRITE GO TAKIM-OKU1.
           PERFORM SATIR-ATA. DISPLAY MAC-BILGILERI.
           MOVE 1 TO SW-WRITE.
       TAKIM-OKU1.
           ACCEPT MAC-TAKIM-AL1. PERFORM ESC-AL.
           IF ESC OR YUKARI GO SATIR-BILGILERI.
           IF F8 GO MAC-IPTAL.
           IF F10 MOVE EKR-TAKIM2 TO KONT-TAKIM-NO
                  PERFORM TAKIM-TABLOSU THRU TAKIM-TABLO-SON
                  MOVE TAKIM-NO TO EKR-TAKIM1 GO TAKIM-KONTROL1.
           IF EKR-TAKIM1=EKR-TAKIM2 OR SW-DIZI-SW(EKR-TAKIM1)="X"
              GO TAKIM-OKU1.
           IF NOT ASAGI GO TAKIM-OKU1.
       TAKIM-KONTROL1.
           IF EKR-TAKIM1=ZEROS OR >18 GO TAKIM-OKU1.
           MOVE TAKIM-DIZI-ADI(EKR-TAKIM1) TO EKR-TAKIM-ADI1.
           IF EKR-TAKIM-ADI1=SPACES GO TAKIM-OKU1.
           DISPLAY MAC-TAKIM-AL1.
       TAKIM-OKU2.
           ACCEPT MAC-TAKIM-AL2. PERFORM ESC-AL.
           IF ESC GO SATIR-BILGILERI. IF YUKARI GO TAKIM-OKU1.
           IF F8 GO MAC-IPTAL.
           IF F10 MOVE EKR-TAKIM1 TO KONT-TAKIM-NO
                  PERFORM TAKIM-TABLOSU THRU TAKIM-TABLO-SON
                  MOVE TAKIM-NO TO EKR-TAKIM2 GO TAKIM-KONTROL2.
           IF EKR-TAKIM2=EKR-TAKIM1 OR SW-DIZI-SW(EKR-TAKIM2)="X"
              GO TAKIM-OKU2.
           IF NOT ASAGI GO TAKIM-OKU1.
       TAKIM-KONTROL2.
           IF EKR-TAKIM2=ZEROS OR >18 GO TAKIM-OKU2.
           MOVE TAKIM-DIZI-ADI(EKR-TAKIM2) TO EKR-TAKIM-ADI2.
           IF EKR-TAKIM-ADI2=SPACES GO TAKIM-OKU2.
           DISPLAY MAC-TAKIM-AL2.
       MAC-SECIM.
           DISPLAY '~W=SATSECIM,NOESC/'.
           ACCEPT (2,2) KARAR WITH AUTO-SKIP. DISPLAY (2,2) " ".
           IF KARAR=2 GO MAC-NO-OKU.
           IF SW-WRITE=0 GO MACI-KAYDET ELSE GO MACI-DUZELT.
       MACI-KAYDET.
           CLOSE FIKSDOS. OPEN I-O FIKSDOS.
           MOVE EKR-HAFTA-NO TO FIKS-HAFTA-NO.
           MOVE EKR-MAC-NO   TO FIKS-MAC-NO.
           MOVE EKR-TAKIM1   TO FIKS-TAKIM1.
           MOVE EKR-TAKIM2   TO FIKS-TAKIM2.
           MOVE ZEROS        TO FIKS-SONUC1 FIKS-SONUC2 FIKS-TEST.
           WRITE FIKSTUR-KAYDI INVALID DISPLAY (2,2) "*".
           MOVE "X" TO SW-DIZI-SW (FIKS-TAKIM1)
                       SW-DIZI-SW (FIKS-TAKIM2).
           CLOSE FIKSDOS. OPEN INPUT FIKSDOS.
           GO HAFTA-START.
       MACI-DUZELT.
           MOVE EKR-HAFTA-NO TO FIKS-HAFTA-NO.
           MOVE EKR-MAC-NO   TO FIKS-MAC-NO.
           READ FIKSDOS INVALID DISPLAY (2,2) "*".
           MOVE " " TO SW-DIZI-SW (FIKS-TAKIM1)
                       SW-DIZI-SW (FIKS-TAKIM2).
           CLOSE FIKSDOS. OPEN I-O FIKSDOS.
           MOVE EKR-HAFTA-NO TO FIKS-HAFTA-NO.
           MOVE EKR-MAC-NO   TO FIKS-MAC-NO.
           MOVE EKR-TAKIM1   TO FIKS-TAKIM1.
           MOVE EKR-TAKIM2   TO FIKS-TAKIM2.
           REWRITE FIKSTUR-KAYDI INVALID DISPLAY (2,2) "*".
           MOVE "X" TO SW-DIZI-SW (FIKS-TAKIM1)
                       SW-DIZI-SW (FIKS-TAKIM2).
           CLOSE FIKSDOS. OPEN INPUT FIKSDOS.
           GO HAFTA-START.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * *                Ma ptal Kontrol ve lemleri               * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       MAC-IPTAL.
           DISPLAY '~W=IPTEMIN,NOESC/'.
           ACCEPT (2,2) KARAR WITH AUTO-SKIP. PERFORM ESC-AL.
           IF ESC GO MAC-NO-OKU. DISPLAY (2,2) " ".
           IF KARAR=2 GO MAC-NO-OKU.
       MAC-IPTAL-ET.
           CLOSE FIKSDOS. OPEN I-O FIKSDOS.
           DELETE FIKSDOS INVALID DISPLAY (2,2) "*".
           MOVE " " TO SW-DIZI-SW (FIKS-TAKIM1)
                       SW-DIZI-SW (FIKS-TAKIM2).
           CLOSE FIKSDOS. OPEN INPUT FIKSDOS.
           GO HAFTA-START.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * *                        TAKIM TABLOSU                        * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       TAKIM-TABLOSU.
           DISPLAY '~W=TABLO,NOWAIT/'.
           MOVE 1 TO TAB-SECIM TAB-ESSEC. MOVE 0 TO TAB-SAY INDIS.
           MOVE SPACES TO SECIM-DIZISI.
       TAKIM-TABLO-OKU.
           ADD 1 TO INDIS. IF INDIS>18 GO TAKIM-SAYFA-DOLDU.
           IF TAKIM-DIZI-ADI(INDIS)=SPACES OR 
              SW-DIZI-SW    (INDIS)="X" OR
              TAKIM-DIZI-NO (INDIS)=KONT-TAKIM-NO GO TAKIM-TABLO-OKU.
           ADD 1 TO TAB-SAY. COMPUTE TAB-LIN=TAB-SAY + 3. 
           MOVE TAB-SAY TO TAB-ESSEC. 
           MOVE TAKIM-DIZI-NO (INDIS) TO SECIM-DIZI-NO (TAB-SAY).
           MOVE TAKIM-DIZI-ADI(INDIS) TO SECIM-DIZI-ADI(TAB-SAY).
           DISPLAY NORMAL-TAKIM-YAZ.
           GO TAKIM-TABLO-OKU.
       TAKIM-SAYFA-DOLDU.
           IF TAB-SAY=0 GO TAKIM-TABLO-CIK.
           DISPLAY (2,79) " ". PERFORM TAKIM-TABLO-KONTROL.
           CALL X"83" USING TAB-INTX. MOVE TAB-INTX TO TAB-DEG.
           IF TAB-ESC   GO TAKIM-TABLO-CIK.
           IF TAB-ENTER GO TAKIM-TABLO-SECME-ISLEMI.
           IF TAB-ASAGI MOVE TAB-SECIM TO TAB-ESSEC
             IF TAB-SECIM=TAB-SAY MOVE 1 TO TAB-SECIM 
                             ELSE ADD  1 TO TAB-SECIM.
           IF TAB-YUKARI MOVE TAB-SECIM TO TAB-ESSEC
             IF TAB-SECIM=1 MOVE TAB-SAY TO TAB-SECIM 
                       ELSE SUBTRACT 1 FROM TAB-SECIM.
           GO TAKIM-SAYFA-DOLDU.
       TAKIM-TABLO-KONTROL.
           COMPUTE TAB-LIN=TAB-ESSEC + 3. DISPLAY NORMAL-TAKIM-YAZ.
           COMPUTE TAB-LIN=TAB-SECIM + 3. DISPLAY PARLAK-TAKIM-YAZ.
       TAKIM-TABLO-SECME-ISLEMI.
           DISPLAY '~C=LAST/'.
           MOVE SECIM-DIZI-NO (TAB-SECIM) TO TAKIM-NO.
           GO TAKIM-TABLO-SON.
       TAKIM-TABLO-CIK.
           DISPLAY '~C=LAST/'. MOVE ZEROS TO TAKIM-NO.
       TAKIM-TABLO-SON.
           EXIT.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
     ***> Alt Perform Sahalar.
       TAKIM-ADLARI-AL.
           OPEN INPUT TAKIMDOS.
           MOVE SPACES TO TAKIM-DIZISI.
       TAKIM-ADLARI-OKU.
           READ TAKIMDOS NEXT AT END GO TAKIM-ADLARI-SON.
           MOVE TAKIM-NO  TO TAKIM-DIZI-NO (TAKIM-NO).
           MOVE TAKIM-ADI TO TAKIM-DIZI-ADI(TAKIM-NO).
           GO TAKIM-ADLARI-OKU.
       TAKIM-ADLARI-SON.
           CLOSE TAKIMDOS.
      *>
       OTOMATIK-MAC-NO.
           MOVE ZEROS        TO ENSON-MAC-NO.
           MOVE EKR-HAFTA-NO TO FIKS-HAFTA-NO.
           MOVE 99           TO FIKS-MAC-NO.
           START FIKSDOS KEY LESS THAN FIKS-KEY
                            INVALID GO OTO-MAC-SON.
       OTO-MAC-OKU.
           READ FIKSDOS NEXT AT END GO OTO-MAC-SON.
           IF EKR-HAFTA-NO NOT=FIKS-HAFTA-NO GO OTO-MAC-SON.
           MOVE FIKS-MAC-NO TO ENSON-MAC-NO.
       OTO-MAC-SON.
           ADD 1 TO ENSON-MAC-NO.
           MOVE ENSON-MAC-NO TO EKR-MAC-NO.
      *>
       OTOMATIK-HAFTA-NO.
           MOVE ZEROS TO ENSON-HAFTA-NO.
           MOVE 99    TO FIKS-HAFTA-NO FIKS-MAC-NO.
           START FIKSDOS KEY LESS THAN FIKS-KEY
                            INVALID GO OTO-HAFTA-SON.
       OTO-HAFTA-OKU.
           READ FIKSDOS NEXT AT END GO OTO-HAFTA-SON.
           MOVE FIKS-HAFTA-NO TO ENSON-HAFTA-NO.
       OTO-HAFTA-SON.
           ADD 1 TO ENSON-HAFTA-NO.
           MOVE ENSON-HAFTA-NO TO EKR-HAFTA-NO.
           DISPLAY HAFTA-BILGILERI.
      *>
       ONCEKI-KAYIT.
           MOVE EKR-HAFTA-NO TO FIKS-HAFTA-NO.
           MOVE ZEROS        TO FIKS-MAC-NO.
           START FIKSDOS KEY LESS THAN FIKS-KEY
                                INVALID GO ONCEKI-SON.
       ONCEKI-OKU.
           READ FIKSDOS PREVIOUS AT END GO ONCEKI-SON.
           MOVE FIKS-HAFTA-NO TO EKR-HAFTA-NO.
           DISPLAY HAFTA-BILGILERI.
       ONCEKI-SON.
           GO HAFTA-NO-OKU.
      *>
       SONRAKI-KAYIT.
           MOVE EKR-HAFTA-NO TO FIKS-HAFTA-NO.
           MOVE 99           TO FIKS-MAC-NO.
           START FIKSDOS KEY GREATER THAN FIKS-KEY
                            INVALID GO SONRAKI-SON.
       SONRAKI-OKU.
           READ FIKSDOS NEXT AT END GO SONRAKI-SON.
           MOVE FIKS-HAFTA-NO TO EKR-HAFTA-NO.
           DISPLAY HAFTA-BILGILERI.
       SONRAKI-SON.
           GO HAFTA-NO-OKU.
* * * *
       SATIR-ATA.
           MOVE FIKS-TAKIM1 TO EKR-TAKIM1.
           MOVE FIKS-TAKIM2 TO EKR-TAKIM2.
       LIG-VE-TARIHI-YAZ.
           ACCEPT BUGUNUN-TARIHI FROM DATE.
           DISPLAY (2,70) BU-GUN.  DISPLAY (2,72) "/".
           DISPLAY (2,73) BU-AY.   DISPLAY (2,75) "/".
           DISPLAY (2,76) BU-YIL.
           OPEN INPUT LIGDOS.
           IF LIGDOS-DURUMU NOT="00" MOVE SPACES TO LIG-KAYDI
                     ELSE READ LIGDOS AT END DISPLAY (2,2) "*".
           CLOSE LIGDOS.
           DISPLAY (2,4) LIG-ADI.
       SIFIRLA.
           MOVE SPACES TO EKR-TAKIM-ADI1 EKR-TAKIM-ADI2.
           MOVE ZEROS  TO EKR-TAKIM1 EKR-TAKIM2.
* * * * Programdan k.
       ESC-AL. ACCEPT ESCKOD FROM ESCAPE KEY.
       PROGRAM-SONU.
           CLOSE FIKSDOS.
           EXIT PROGRAM.
