       IDENTIFICATION DIVISION.
       PROGRAM-ID.    LIGMENU.
       SECURITY.      Lig Fikstr Program Mens.
       AUTHOR.        Serkan Uzuner - Eyll'92.
       ENVIRONMENT    DIVISION.
       INPUT-OUTPUT   SECTION.
       FILE-CONTROL.
           COPY LIGFIKS.FLC.
           COPY LIGTAKIM.FLC.
           COPY LIGPARAM.FLC.
       DATA DIVISION.
       FILE SECTION.
           COPY LIGFIKS.LIB.
           COPY LIGTAKIM.LIB.  
           COPY LIGPARAM.LIB.  
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       WORKING-STORAGE SECTION.
       77 YER  PIC 99 VALUE 1.
       77 ESKI PIC 99 VALUE 0.
       01 BUGUNUN-TARIHI.
           02 BU-YIL PIC 99 VALUE 0.
           02 BU-AY  PIC 99 VALUE 0.
           02 BU-GUN PIC 99 VALUE 0.
       77 LIGDOS-DURUMU PIC XX VALUE SPACES.
      *> Tu Kontrolleri.
       77 INTX  PIC 9 COMP-0 VALUE 0.
       77 TUS   PIC 9(4) VALUE 0.
       77 ESC   PIC 9(4) VALUE 6912. 77 SEC    PIC 9(4) VALUE 3328.
       77 F1    PIC 9(4) VALUE 5104. 77 F2     PIC 9(4) VALUE 5360.
       77 F3    PIC 9(4) VALUE 5616. 77 F4     PIC 9(4) VALUE 5872.
       77 ASAGI PIC 9(4) VALUE 0480. 77 YUKARI PIC 9(4) VALUE 8432.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       SCREEN SECTION.
       01 MENU-EKR.
           02 BLANK SCREEN.
           02 LINE 01 COLUMN  1
           "
      -    "".
           02 LINE 02 COLUMN  1
           "
      -    "".
           02 LINE 03 COLUMN 1
           "
      -    "Ŀ".
           02 LINE 04 COLUMN 1
           "
      -    "/  /   ".
           02 LINE 05 COLUMN 1
           "
      -    "ĳ".
           02 LINE 06 COLUMN 1
           "       Ŀ
      -    "       ".
           02 LINE 07 COLUMN 1
           "                                         
      -    "       ".
           02 LINE 08 COLUMN 1
           "                                         
      -    "       ".
           02 LINE 09 COLUMN 1
           "                                         
      -    "       ".
           02 LINE 10 COLUMN 1
           "                                         
      -    "       ".
           02 LINE 11 COLUMN 1
           "                                         
      -    "       ".
           02 LINE 12 COLUMN 1
           "                                         
      -    "       ".
           02 LINE 13 COLUMN 1
           "                                         
      -    "       ".
           02 LINE 14 COLUMN 1
           "                                         
      -    "       ".
           02 LINE 15 COLUMN 1
           "                                         
      -    "       ".
           02 LINE 16 COLUMN 1
           "                                         
      -    "       ".
           02 LINE 17 COLUMN 1
           "                                         
      -    "       ".
           02 LINE 18 COLUMN 1
           "       
      -    "       ".
           02 LINE 19 COLUMN 1
           "
      -    "ĳ".
           02 LINE 20 COLUMN 1
           "
      -    "       ".
           02 LINE 21 COLUMN 1
           "
      -    "ٰ".
           02 LINE 22 COLUMN  1
           "
      -    "".
           02 LINE 23 COLUMN  1
           "
      -    "".
           02 LINE 24 COLUMN  1
           "
      -    "".
           02 LINE 25 COLUMN  1
           "
      -    "".
           02 LINE 20 COLUMN 25
                "   (c) Copyright by SERUZ  - 1992  " HIGHLIGHT.
           02 LINE 05 COLUMN 31 " FUTBOL LG PROGRAMI " REVERSE-VIDEO.
           02 LINE 04 COLUMN 20 PIC X(30) FROM LIG-ADI HIGHLIGHT.
           02         COLUMN 59 PIC ZZ FROM BU-GUN HIGHLIGHT.
           02         COLUMN 62 PIC ZZ FROM BU-AY  HIGHLIGHT.
           02         COLUMN 65 PIC ZZ FROM BU-YIL HIGHLIGHT.
       01 BOS. 02 LINE 00 COLUMN 00 " ".
       01 NORMAL-MENU.
         02 MENU1.
           03 LINE 08 COLUMN 27 "  F1.  Puan Durumu              ".
         02 MENU2.
           03 LINE 10 COLUMN 27 "  F2.  Lig Fikstr             ".
         02 MENU3.
           03 LINE 12 COLUMN 27 "  F3.  Takm Fikstr           ".
         02 MENU4.
           03 LINE 14 COLUMN 27 "  F4.  Lig Sonular Girii     ".
         02 MENU5.
           03 LINE 16 COLUMN 27 "  Esc. Programdan kma         ".
       01 PARLAK-MENU REVERSE-VIDEO.
         02 MENU-R1.
           03 LINE 08 COLUMN 27 "  F1.  Puan Durumu              ".
         02 MENU-R2.
           03 LINE 10 COLUMN 27 "  F2.  Lig Fikstr             ".
         02 MENU-R3.
           03 LINE 12 COLUMN 27 "  F3.  Takm Fikstr           ".
         02 MENU-R4.
           03 LINE 14 COLUMN 27 "  F4.  Lig Sonular Girii     ".
         02 MENU-R5.
           03 LINE 16 COLUMN 27 "  Esc. Programdan kma         ".
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       PROCEDURE DIVISION.
       BASLA.
           PERFORM LIG-VE-TARIHI-AL.
           DISPLAY MENU-EKR NORMAL-MENU.
           PERFORM KONTROL.
       CEVAP-AL. DISPLAY BOS.
           CALL X"83" USING INTX. MOVE INTX TO TUS.
           EVALUATE TUS
                WHEN ESC DISPLAY (1,1) ERASE STOP RUN
                WHEN SEC PERFORM GONDER GO BASLA
                WHEN F1 CALL "LIGPUAN"  CANCEL "LIGPUAN"  GO BASLA
                WHEN F2 CALL "LIGFIKST" CANCEL "LIGFIKST" GO BASLA
                WHEN F3 CALL "LIGTKFKS" CANCEL "LIGTKFKS" GO BASLA
                WHEN F4 CALL "LIGSONUC" CANCEL "LIGSONUC" GO BASLA
                WHEN ASAGI  MOVE YER TO ESKI
                     IF YER=5 MOVE 1 TO YER 
                         ELSE ADD  1 TO YER
                     END-IF PERFORM KONTROL
                WHEN YUKARI MOVE YER TO ESKI
                     IF YER=1 MOVE 5 TO YER 
                         ELSE SUBTRACT 1 FROM YER
                     END-IF PERFORM KONTROL
           END-EVALUATE
           GO CEVAP-AL.
       GONDER.
           EVALUATE YER  WHEN 1 CALL "LIGPUAN"  CANCEL "LIGPUAN"
                         WHEN 2 CALL "LIGFIKST" CANCEL "LIGFIKST"
                         WHEN 3 CALL "LIGTKFKS" CANCEL "LIGTKFKS"
                         WHEN 4 CALL "LIGSONUC" CANCEL "LIGSONUC"
                         WHEN 5 DISPLAY (1,1) ERASE STOP RUN.
       KONTROL.
           EVALUATE ESKI WHEN 1 DISPLAY MENU1
                         WHEN 2 DISPLAY MENU2
                         WHEN 3 DISPLAY MENU3
                         WHEN 4 DISPLAY MENU4
                         WHEN 5 DISPLAY MENU5.
           EVALUATE YER  WHEN 1 DISPLAY MENU-R1
                         WHEN 2 DISPLAY MENU-R2
                         WHEN 3 DISPLAY MENU-R3
                         WHEN 4 DISPLAY MENU-R4
                         WHEN 5 DISPLAY MENU-R5.
       LIG-VE-TARIHI-AL.
           ACCEPT BUGUNUN-TARIHI FROM DATE.
           OPEN INPUT LIGDOS.
           IF LIGDOS-DURUMU="00" READ LIGDOS
              ELSE MOVE SPACES TO LIG-ADI.
           CLOSE LIGDOS.
