       IDENTIFICATION DIVISION.
       PROGRAM-ID.    LIGSONUC.
       SECURITY.      Lig Sonular Girii.
       AUTHOR.        Serkan Uzuner - Eyll'92.
       ENVIRONMENT    DIVISION.
       INPUT-OUTPUT   SECTION.
       FILE-CONTROL.
           COPY LIGFIKS.FLC.
           COPY LIGTAKIM.FLC.
           COPY LIGPARAM.FLC.
       DATA DIVISION.
       FILE SECTION.
           COPY LIGFIKS.LIB.
           COPY LIGTAKIM.LIB.  
           COPY LIGPARAM.LIB.  
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       WORKING-STORAGE SECTION.
       77 EKR-HAFTA-NO   PIC 9(2)  VALUE ZEROS.
       77 EKR-MAC-NO     PIC 9(5)  VALUE ZEROS.
       77 EKR-SONUC1     PIC 9(2)  VALUE ZEROS.
       77 EKR-SONUC2     PIC 9(2)  VALUE ZEROS.
       77 EKR-TAKIM-ADI1 PIC X(20) VALUE SPACES.
       77 EKR-TAKIM-ADI2 PIC X(20) VALUE SPACES.
       77 SAT            PIC 99    VALUE ZEROS.
       77 SATIR          PIC 99    VALUE ZEROS.
       01 BUGUNUN-TARIHI.
           02 BU-YIL PIC 99. 02 BU-AY PIC 99. 02 BU-GUN PIC 99.
       01 ESCKOD      PIC 99.
           88 ASAGI VALUE 00. 88 ESC    VALUE 01. 88 F1  VALUE 02. 
           88 F2    VALUE 03. 88 F3     VALUE 04. 88 F8  VALUE 09.
           88 F10   VALUE 11. 88 YUKARI VALUE 99.
       77 LIGDOS-DURUMU PIC XX VALUE SPACES.
       01 TAKIM-DIZISI.
           02 TAKIM-DIZI-DATA    OCCURS 18 TIMES.
               03 TAKIM-DIZI-NO  PIC Z(2)  VALUE ZEROS.
               03 TAKIM-DIZI-ADI PIC X(20) VALUE SPACES.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       SCREEN SECTION.
       01 HAFTA-NO-AL.
           02 LINE 06 COLUMN 42 PIC Z(2) USING EKR-HAFTA-NO.
       01 MAC-SONUC-AL.
           02 LINE SATIR COLUMN 40 PIC Z9 USING EKR-SONUC1.
           02            COLUMN 64 PIC Z9 USING EKR-SONUC2.
       01 MAC-DETAY-BILGISI.
           02 LINE SAT COLUMN 15 PIC BZZ   FROM EKR-MAC-NO.
           02          COLUMN 19 PIC X(20) FROM EKR-TAKIM-ADI1.
           02          COLUMN 40 PIC Z9    FROM EKR-SONUC1.
           02          COLUMN 43 PIC X(20) FROM EKR-TAKIM-ADI2.
           02          COLUMN 64 PIC Z9    FROM EKR-SONUC2.
       01 MAC-DETAY-BILGISI-BOS.
           02 LINE SAT COLUMN 15 "   ".
           02          COLUMN 19 "                    ".
           02          COLUMN 40 "  ".
           02          COLUMN 43 "                    ".
           02          COLUMN 64 "  ".
       01 MAC-OYNANMADI.
           02 LINE SAT   COLUMN 40 "--". 02 COLUMN 64 "--".
       01 MAC-OYNANMADI2.
           02 LINE SATIR COLUMN 40 "--". 02 COLUMN 64 "--".
       01 SONUC-ISLEMLERI REVERSE-VIDEO.
           02 LINE  1  COLUMN 28 " S O N U      L E M L E R  ".
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       PROCEDURE DIVISION.
       BASLA.
           DISPLAY (1,1) ERASE.
           DISPLAY '~C=ALL/'.
           DISPLAY '~L=LIGMENU/'.
           DISPLAY '~W=LIGSONUC,NOWAIT/'.
           PERFORM TAKIM-ADLARI-AL THRU TAKIM-ADLARI-SON.
           DISPLAY SONUC-ISLEMLERI.
           PERFORM LIG-VE-TARIHI-YAZ.
           OPEN INPUT FIKSDOS.
           DISPLAY HAFTA-NO-AL.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * *         Hafta No Okuma ve Dosyadan Kontrol Etme             * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       HAFTA-NO-OKU.
           ACCEPT HAFTA-NO-AL. PERFORM ESC-AL. IF ESC GO PROGRAM-SONU.
           IF F2 GO SONRAKI-HAFTA. IF F3 GO ONCEKI-HAFTA.
           IF EKR-HAFTA-NO=ZEROS OR NOT ASAGI GO HAFTA-NO-OKU.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * *                          Haftay Yazdrma                   * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       HAFTA-START.
           PERFORM SAYFA-TEMIZLE VARYING SAT FROM 10 BY 1 UNTIL SAT>18.
           MOVE 9 TO SAT. MOVE 10 TO SATIR.
           MOVE EKR-HAFTA-NO TO FIKS-HAFTA-NO.
           MOVE ZEROS        TO FIKS-MAC-NO.
           START FIKSDOS KEY NOT < FIKS-KEY INVALID GO SONUC-OKU.
       EKRAN-KAYIT-OKU.
           READ FIKSDOS NEXT AT END GO SONUC-OKU.
           IF EKR-HAFTA-NO NOT=FIKS-HAFTA-NO GO SONUC-OKU.
           ADD 1 TO SAT. PERFORM EKRAN-DETAY-YAZ.
           IF SAT=18 GO SONUC-OKU ELSE GO EKRAN-KAYIT-OKU.
       EKRAN-DETAY-YAZ.
           MOVE FIKS-MAC-NO TO EKR-MAC-NO.
           MOVE FIKS-SONUC1 TO EKR-SONUC1.
           MOVE FIKS-SONUC2 TO EKR-SONUC2.
           MOVE TAKIM-DIZI-ADI (FIKS-TAKIM1) TO EKR-TAKIM-ADI1.
           MOVE TAKIM-DIZI-ADI (FIKS-TAKIM2) TO EKR-TAKIM-ADI2.
           DISPLAY MAC-DETAY-BILGISI.
           IF FIKS-TEST=0 DISPLAY MAC-OYNANMADI.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * *                    Ma Sonular lemleri                  * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       SONUC-OKU.
           IF SAT=9 GO HAFTA-NO-OKU. PERFORM MAC-SONUCUNU-OKU.
           ACCEPT MAC-SONUC-AL. PERFORM ESC-AL. 
           IF ESC IF FIKS-TEST=0 DISPLAY MAC-OYNANMADI2 END-IF
                  GO HAFTA-NO-OKU.
           IF F8 MOVE 0 TO FIKS-TEST EKR-SONUC1 EKR-SONUC2
                 DISPLAY MAC-OYNANMADI2 ELSE MOVE 1 TO FIKS-TEST.
           IF ASAGI OR YUKARI OR F8 PERFORM MAC-SONUCUNU-YAZ.
           IF ASAGI OR F8 IF SATIR=SAT MOVE 10 TO SATIR 
                                  ELSE ADD  1  TO SATIR.
           IF YUKARI IF SATIR NOT=10 SUBTRACT 1 FROM SATIR.
           GO SONUC-OKU.
       MAC-SONUCUNU-OKU.
           MOVE EKR-HAFTA-NO TO FIKS-HAFTA-NO.
           COMPUTE FIKS-MAC-NO = SATIR - 9.
           READ FIKSDOS INVALID DISPLAY (2,2) "*".
           MOVE FIKS-SONUC1 TO EKR-SONUC1.
           MOVE FIKS-SONUC2 TO EKR-SONUC2.
       MAC-SONUCUNU-YAZ.
           MOVE EKR-HAFTA-NO TO FIKS-HAFTA-NO.
           COMPUTE FIKS-MAC-NO = SATIR - 9.
           MOVE EKR-SONUC1 TO FIKS-SONUC1.
           MOVE EKR-SONUC2 TO FIKS-SONUC2.
           CLOSE FIKSDOS. OPEN I-O FIKSDOS.
           REWRITE FIKSTUR-KAYDI INVALID DISPLAY (2,2) "*".
           CLOSE FIKSDOS. OPEN INPUT FIKSDOS.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
     ***> Alt Perform Sahalar.
       TAKIM-ADLARI-AL.
           OPEN INPUT TAKIMDOS.
           MOVE SPACES TO TAKIM-DIZISI.
       TAKIM-ADLARI-OKU.
           READ TAKIMDOS NEXT AT END GO TAKIM-ADLARI-SON.
           MOVE TAKIM-NO  TO TAKIM-DIZI-NO (TAKIM-NO).
           MOVE TAKIM-ADI TO TAKIM-DIZI-ADI(TAKIM-NO).
           GO TAKIM-ADLARI-OKU.
       TAKIM-ADLARI-SON.
           CLOSE TAKIMDOS. EXIT.
      *>
       SONRAKI-HAFTA.
           MOVE EKR-HAFTA-NO TO FIKS-HAFTA-NO.
           MOVE 99           TO FIKS-MAC-NO.
           START FIKSDOS KEY GREATER THAN FIKS-KEY
                            INVALID GO SONRAKI-SON.
       SONRAKI-OKU.
           READ FIKSDOS NEXT AT END GO SONRAKI-SON.
           MOVE FIKS-HAFTA-NO TO EKR-HAFTA-NO.
           DISPLAY HAFTA-NO-AL.
       SONRAKI-SON.
           GO HAFTA-NO-OKU.
      *>
       ONCEKI-HAFTA.
           MOVE EKR-HAFTA-NO TO FIKS-HAFTA-NO.
           MOVE ZEROS        TO FIKS-MAC-NO.
           START FIKSDOS KEY LESS THAN FIKS-KEY
                                INVALID GO ONCEKI-SON.
       ONCEKI-OKU.
           READ FIKSDOS PREVIOUS AT END GO ONCEKI-SON.
           MOVE FIKS-HAFTA-NO TO EKR-HAFTA-NO.
           DISPLAY HAFTA-NO-AL.
       ONCEKI-SON.
           GO HAFTA-NO-OKU.
      *>
       SAYFA-TEMIZLE.  DISPLAY MAC-DETAY-BILGISI-BOS.
       ESC-AL. ACCEPT ESCKOD FROM ESCAPE KEY.
      *>
       LIG-VE-TARIHI-YAZ.
           ACCEPT BUGUNUN-TARIHI FROM DATE.
           DISPLAY (2,70) BU-GUN (2,72) "/" 
                   (2,73) BU-AY  (2,75) "/" BU-YIL.
           OPEN INPUT LIGDOS.
           IF LIGDOS-DURUMU NOT="00" MOVE SPACES TO LIG-KAYDI
                     ELSE READ LIGDOS AT END DISPLAY (2,2) "*".
           CLOSE LIGDOS. DISPLAY (2,4) LIG-ADI.
      *> Programdan k.
       PROGRAM-SONU.
           CLOSE FIKSDOS.
           EXIT PROGRAM.
