       IDENTIFICATION DIVISION.
       PROGRAM-ID.    LIGTKFKS.
       SECURITY.      Takm Fikstr.
       AUTHOR.        Serkan Uzuner - Eyll'92.
       ENVIRONMENT    DIVISION.
       INPUT-OUTPUT   SECTION.
       FILE-CONTROL.
           COPY LIGFIKS.FLC.
           COPY LIGTAKIM.FLC.
           COPY LIGPARAM.FLC.
       DATA DIVISION.
       FILE SECTION.
           COPY LIGFIKS.LIB.
           COPY LIGTAKIM.LIB.  
           COPY LIGPARAM.LIB.  
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       WORKING-STORAGE SECTION.
       77 EKR-TAKIM-NO     PIC 9(2) VALUE ZEROS.
       77 1YARI-MAC-SAYISI PIC 9(2) VALUE ZEROS.
       77 SATIR            PIC 99   VALUE 0.
       77 SW-YARI          PIC 99   VALUE 0.
       01 BUGUNUN-TARIHI.
           02 BU-YIL PIC 99. 02 BU-AY PIC 99. 02 BU-GUN PIC 99.
       01 ESCKOD PIC 99.
           88 ASAGI VALUE 00. 88 ESC    VALUE 01. 88 F2 VALUE 03.
           88 F10   VALUE 11. 88 YUKARI VALUE 99. 88 F3 VALUE 04.
       77 LIGDOS-DURUMU PIC XX VALUE SPACES.
       01 TAKIM-DIZISI.
           02 TAKIM-DIZI-DATA     OCCURS 18 TIMES.
               03 TAKIM-DIZI-NO   PIC Z(2)  VALUE ZEROS.
               03 TAKIM-DIZI-ADI  PIC X(20) VALUE SPACES.
      *> Tablo Deikenleri.
       77 TAB-LIN   PIC 99 VALUE 0.
       77 TAB-SAY   PIC 99 VALUE 0.
       77 TAB-SECIM PIC 99 VALUE 1.
       77 TAB-ESSEC PIC 99 VALUE 1.
       77 TAB-INTX  PIC 9  COMP-0 VALUE 0.
       01 TAB-DEG PIC 9(4) VALUE 0.
           88 TAB-ESC   VALUE 6912. 88 TAB-ENTER  VALUE 3328.
           88 TAB-ASAGI VALUE 0480. 88 TAB-YUKARI VALUE 8432.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       SCREEN SECTION.
       01 TAKIM-NO-AL HIGHLIGHT.
           02 LINE 02 COLUMN 13 PIC Z(2)  USING EKR-TAKIM-NO.
           02         COLUMN 18 PIC X(20) FROM  TAKIM-ADI.
       01 MAC-DETAY-BILGISI1.
           02 LINE SATIR COLUMN 03 PIC ZZ    FROM FIKS-HAFTA-NO.
           02            COLUMN 06 PIC X(14) FROM  
                                       TAKIM-DIZI-ADI(FIKS-TAKIM1).
           02            COLUMN 21 PIC X(13) FROM
                                       TAKIM-DIZI-ADI(FIKS-TAKIM2).
           02            COLUMN 35 PIC Z9    FROM FIKS-SONUC1.
           02            COLUMN 37 "-".
           02            COLUMN 38 PIC Z9    FROM FIKS-SONUC2.
       01 MAC-DETAY-BILGISI2.
           02 LINE SATIR COLUMN 42 PIC ZZ    FROM FIKS-HAFTA-NO.
           02            COLUMN 45 PIC X(14) FROM  
                                       TAKIM-DIZI-ADI(FIKS-TAKIM1).
           02            COLUMN 60 PIC X(13) FROM
                                       TAKIM-DIZI-ADI(FIKS-TAKIM2).
           02            COLUMN 74 PIC Z9    FROM FIKS-SONUC1.
           02            COLUMN 76 "-".
           02            COLUMN 77 PIC Z9    FROM FIKS-SONUC2.
       01 MAC-DETAY-BILGISI-BOS.
           02 LINE SATIR COLUMN 03 "  ".
           02            COLUMN 06 "              ".
           02            COLUMN 21 "             ".
           02            COLUMN 35 "     ".
           02            COLUMN 42 "  ".
           02            COLUMN 45 "              ".
           02            COLUMN 60 "             ".
           02            COLUMN 74 "     ".
       01 MAC-OYNANMADI1.
           02 LINE SATIR COLUMN 35 "  -  ".
       01 MAC-OYNANMADI2.
           02 LINE SATIR COLUMN 74 "  -  ".
      * Takm Tablosunda Ik Kontrolleri.
       01 NORMAL-TAKIM-YAZ.
           02 LINE TAB-LIN COLUMN 53 PIC BZZB    
                                     FROM TAKIM-DIZI-NO (TAB-ESSEC).
           02              COLUMN 58 PIC BX(20)B 
                                     FROM TAKIM-DIZI-ADI(TAB-ESSEC).
       01 PARLAK-TAKIM-YAZ REVERSE-VIDEO.
           02 LINE TAB-LIN COLUMN 53 PIC BZZB    
                                     FROM TAKIM-DIZI-NO (TAB-SECIM).
           02              COLUMN 58 PIC BX(20)B 
                                     FROM TAKIM-DIZI-ADI(TAB-SECIM).
       01 TAKIM-FIKSTURU.
           02 LINE 01 COLUMN 25 " T A K I M   F  K S T  R  "
               REVERSE-VIDEO.
           02 LINE 02 COLUMN 45 PIC X(30) FROM LIG-ADI HIGHLIGHT.
           02 LINE 24 COLUMN 02 REVERSE-VIDEO
           " Sonraki Takm <F2>,nceki Takm <F3>, Takm Tablosu <F10>, 
      -    "kmak iin <Esc> ".
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       PROCEDURE DIVISION.
       BASLA.
           DISPLAY (1,1) ERASE.
           DISPLAY '~C=ALL/'.
           DISPLAY '~L=LIGMENU/'.
           DISPLAY '~W=LIGTKFKS,NOWAIT/'.
           PERFORM TAKIM-ADLARI-AL THRU TAKIM-ADLARI-SON.
           PERFORM LIG-VE-TARIHI-YAZ.
           OPEN INPUT FIKSDOS.
           MOVE SPACES TO TAKIM-ADI.
           DISPLAY TAKIM-NO-AL.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * *         Takm No Okuma ve Dosyadan Kontrol Etme             * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       TAKIM-NO-OKU.
           ACCEPT TAKIM-NO-AL. PERFORM ESC-AL. IF ESC GO PROGRAM-SONU.
           IF F2 GO SONRAKI-TAKIM. IF F3 GO ONCEKI-TAKIM.
           IF F10 PERFORM TAKIM-TABLOSU THRU TAKIM-TABLO-SON 
                  GO DOSYA-KONTROL.
           IF EKR-TAKIM-NO=ZEROS OR NOT ASAGI GO TAKIM-NO-OKU.
       DOSYA-KONTROL.
           OPEN INPUT TAKIMDOS.
           MOVE EKR-TAKIM-NO TO TAKIM-NO.
           READ TAKIMDOS INVALID CLOSE TAKIMDOS GO TAKIM-NO-OKU.
           CLOSE TAKIMDOS. DISPLAY TAKIM-NO-AL.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * *                      Fikstr  Yazdrma                     * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       TAKIM-START.
           PERFORM TEMIZLE VARYING SATIR FROM 6 BY 1 UNTIL SATIR>22.
           MOVE 6 TO SATIR. MOVE 1 TO SW-YARI.
           MOVE ZEROS TO FIKS-KEY.
           START FIKSDOS KEY NOT LESS THAN FIKS-KEY
                            INVALID GO TAKIM-NO-OKU.
       EKRAN-KAYIT-OKU.
           READ FIKSDOS NEXT AT END GO TAKIM-NO-OKU.
           IF EKR-TAKIM-NO NOT=FIKS-TAKIM1 AND NOT=FIKS-TAKIM2 
                                           GO EKRAN-KAYIT-OKU.
           PERFORM EKRAN-DETAY-YAZ.
           IF 1YARI-MAC-SAYISI=(SATIR - 6) AND SW-YARI=1
                            MOVE 6 TO SATIR MOVE 2 TO SW-YARI.
           IF 1YARI-MAC-SAYISI=(SATIR - 6) AND SW-YARI=2
                            GO TAKIM-NO-OKU.
           GO EKRAN-KAYIT-OKU.
       EKRAN-DETAY-YAZ.
           IF SW-YARI=1 DISPLAY MAC-DETAY-BILGISI1 
                   ELSE DISPLAY MAC-DETAY-BILGISI2.
           IF FIKS-TEST=0 AND SW-YARI=1 DISPLAY MAC-OYNANMADI1.
           IF FIKS-TEST=0 AND SW-YARI=2 DISPLAY MAC-OYNANMADI2.
           ADD 1 TO SATIR.
       TEMIZLE. DISPLAY MAC-DETAY-BILGISI-BOS.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * *                           TAKIM TABLOSU                     * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       TAKIM-TABLOSU.
           OPEN INPUT TAKIMDOS.
           DISPLAY "~W=TABLO,NOESC,NOWAIT,NOCLEAR/".
           MOVE ZEROS TO TAKIM-NO.
           START TAKIMDOS KEY NOT LESS THAN TAKIM-KEY
                             INVALID GO TAKIM-TABLO-CIK.
           MOVE 1 TO TAB-SECIM TAB-ESSEC. MOVE 0 TO TAB-SAY.
           MOVE SPACES TO TAKIM-DIZISI.
       TAKIM-TABLO-OKU.
           READ TAKIMDOS NEXT AT END GO TAKIM-SAYFA-DOLDU.
           ADD 1 TO TAB-SAY.
           MOVE TAKIM-NO  TO TAKIM-DIZI-NO  (TAB-SAY).
           MOVE TAKIM-ADI TO TAKIM-DIZI-ADI (TAB-SAY).
           COMPUTE TAB-LIN=TAB-SAY + 3. MOVE TAB-SAY TO TAB-ESSEC.
           DISPLAY NORMAL-TAKIM-YAZ.
           IF TAB-SAY=18 GO TAKIM-SAYFA-DOLDU ELSE GO TAKIM-TABLO-OKU.
       TAKIM-SAYFA-DOLDU.
           IF TAB-SAY=0 GO TAKIM-TABLO-CIK.
           DISPLAY (2,79) " ". PERFORM TAKIM-TABLO-KONTROL.
           CALL X"83" USING TAB-INTX. MOVE TAB-INTX TO TAB-DEG.
           IF TAB-ESC   GO TAKIM-TABLO-CIK.
           IF TAB-ENTER GO TAKIM-TABLO-SECME-ISLEMI.
           IF TAB-ASAGI MOVE TAB-SECIM TO TAB-ESSEC
             IF TAB-SECIM=TAB-SAY MOVE 1 TO TAB-SECIM 
                             ELSE ADD  1 TO TAB-SECIM.
           IF TAB-YUKARI MOVE TAB-SECIM TO TAB-ESSEC
             IF TAB-SECIM=1 MOVE TAB-SAY TO TAB-SECIM 
                       ELSE SUBTRACT 1 FROM TAB-SECIM.
           GO TAKIM-SAYFA-DOLDU.
       TAKIM-TABLO-KONTROL.
           COMPUTE TAB-LIN=TAB-ESSEC + 3. DISPLAY NORMAL-TAKIM-YAZ.
           COMPUTE TAB-LIN=TAB-SECIM + 3. DISPLAY PARLAK-TAKIM-YAZ.
       TAKIM-TABLO-SECME-ISLEMI.
           CLOSE TAKIMDOS. DISPLAY "~C=LAST/".
           MOVE TAKIM-DIZI-NO (TAB-SECIM) TO EKR-TAKIM-NO.
           GO TAKIM-TABLO-SON.
       TAKIM-TABLO-CIK.
           CLOSE TAKIMDOS. DISPLAY "~C=LAST/".
           MOVE ZEROS TO EKR-TAKIM-NO.
       TAKIM-TABLO-SON.
           EXIT.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
     ***> Alt Perform Sahalar.
       TAKIM-ADLARI-AL.
           OPEN INPUT TAKIMDOS.
           MOVE SPACES TO TAKIM-DIZISI.
           MOVE ZEROS  TO 1YARI-MAC-SAYISI.
       TAKIM-ADLARI-OKU.
           READ TAKIMDOS NEXT AT END GO TAKIM-ADLARI-SON.
           MOVE TAKIM-NO  TO TAKIM-DIZI-NO (TAKIM-NO).
           MOVE TAKIM-ADI TO TAKIM-DIZI-ADI(TAKIM-NO).
           ADD 1 TO 1YARI-MAC-SAYISI.
           GO TAKIM-ADLARI-OKU.
       TAKIM-ADLARI-SON.
           SUBTRACT 1 FROM 1YARI-MAC-SAYISI.
           CLOSE TAKIMDOS. EXIT.
      *>
       SONRAKI-TAKIM.
           OPEN INPUT TAKIMDOS.
           MOVE EKR-TAKIM-NO TO TAKIM-NO.
           START TAKIMDOS KEY GREATER THAN TAKIM-KEY 
                             INVALID GO SONRAKI-SON.
       SONRAKI-OKU.
           READ TAKIMDOS NEXT AT END GO SONRAKI-SON.
           MOVE TAKIM-NO TO EKR-TAKIM-NO.
           DISPLAY TAKIM-NO-AL.
           CLOSE TAKIMDOS.
           GO TAKIM-START.
       SONRAKI-SON.
           CLOSE TAKIMDOS.
           GO TAKIM-NO-OKU.
      *>
       ONCEKI-TAKIM.
           OPEN INPUT TAKIMDOS.
           MOVE EKR-TAKIM-NO TO TAKIM-NO.
           START TAKIMDOS KEY LESS THAN TAKIM-KEY INVALID GO ONCEKI-SON.
       ONCEKI-OKU.
           READ TAKIMDOS PREVIOUS AT END GO ONCEKI-SON.
           MOVE TAKIM-NO TO EKR-TAKIM-NO.
           DISPLAY TAKIM-NO-AL.
           CLOSE TAKIMDOS.
           GO TAKIM-START.
       ONCEKI-SON.
           CLOSE TAKIMDOS.
           GO TAKIM-NO-OKU.
      *>
       LIG-VE-TARIHI-YAZ.
           ACCEPT BUGUNUN-TARIHI FROM DATE.
           OPEN INPUT LIGDOS.
           IF LIGDOS-DURUMU NOT="00" MOVE SPACES TO LIG-KAYDI
                     ELSE READ LIGDOS AT END DISPLAY (2,2) "*".
           CLOSE LIGDOS.
           DISPLAY TAKIM-FIKSTURU.
      *> Programdan k.
       ESC-AL. ACCEPT ESCKOD FROM ESCAPE KEY.
       PROGRAM-SONU.
           CLOSE FIKSDOS.
           EXIT PROGRAM.
