
predicates
kari_koca(symbol,symbol)
evli(symbol,symbol)
anne(symbol,symbol)
baba(symbol,symbol)
kaynana(symbol,symbol)
kayinbaba(symbol,symbol)
amca(symbol,symbol)
dayi(symbol,symbol)
hala(symbol,symbol)
teyze(symbol,symbol)
dede(symbol,symbol)
anneanne(symbol,symbol)
babaanne(symbol,symbol)
erkek(symbol,symbol)
kadin(symbol,symbol)
erkekkardes(symbol,symbol)
kizkardes(symbol,symbol)
kim(symbol,symbol)

clauses
/* Veri Taban */
erkek(ali).
erkek(ahmet).
erkek(abdullah).
erkek(tamer).
erkek(mehmet).
erkek(mustafa).
erkek(mahmut).
erkek(tanju).
kadin(ayse).
kadin(ayla).
kadin(muge).
kadin(meral).
kari_koca(ayse,ali).
kari_koca(muge,mehmet).
kari_koca(ayla,mustafa).
kari_koca(meral,abdullah).
anne(ayse,ayla).
anne(ayse,ahmet).
anne(ayse,abdullah).
anne(ayla,tamer).
anne(muge,mustafa).
anne(muge,mahmut).
anne(muge,meral).
anne(meral,tanju).
baba(ali,ayla).
baba(ali,ahmet).
baba(ali,abdullah).
baba(mustafa,tamer).
baba(mehmet,mustafa).
baba(mehmet,mahmut).
baba(mehmet,meral).
baba(abdullah,tanju).

/* kural taban */

evli(X,Y)        :- kari_koca(X,Y) or kari_koca(Y,X).
erkekkardes(X,Y) :- anne(A,X) and anne(A,Y) and erkek(X).
kizkardes(X,Y)   :- anne(A,X) and anne(A,Y) and kadin(X).
amca(X,Y)        :- baba(B,Y) and erkekkardes(X,B).
dayi(X,Y)        :- anne(A,Y) and erkekkardes(X,A).
hala(X,Y)        :- baba(B,Y) and kizkardes(X,B).
teyze(X,Y)       :- anne(A,Y) and kizkardes(X,A).
kaynana(X,Y)     :- evli(Y,Z) and anne(X,Z).
kayinbaba(X,Y)   :- evli(Y,Z) and baba(X,Z).
dede(X,Y)        :- baba(Z,Y) and baba(X,Z).
dede(X,Y)        :- anne(Z,Y) and baba(X,Z).
anneanne(X,Y)    :- anne(Z,Y) and anne(X,Z).
babaanne(X,Y)    :- baba(Z,Y) and anne(X,Z).

/* bilmecenin tanmlanmas */

kim(X) :- anne(Ax,X) and anne(At,tanju) and kaynana(Ax,At) and erkek(X).


