Program VGA_Renk;

uses crt,graph;
var
  grDriver : Integer;
  p,r,g,b  : pointer;
  grMode   : Integer;
  s        : string;
  size     : integer;
  a        : byte;
  kp       : char;
  rx,gx,bx : integer;

  ErrCode  : Integer;


procedure grafik;
begin
  grDriver := Detect;
  InitGraph(grDriver,grMode,'c:\tp6\bgi');    {burada BGI ve TPU dosyalarinin yerlerine}
  ErrCode := GraphResult;                     {gore gerekli degisiklikleri yapmalisiniz}
  if ErrCode <> grOk then
    begin
    closegraph;
    WriteLn('Graphics error:',
            GraphErrorMsg(ErrCode));
            end;

end;

procedure palet;
begin
setfillstyle(solidfill,darkgray);
bar(163,123,503,253);
setfillstyle(solidfill,white);
bar(161,121,501,251);
setfillstyle(solidfill,lightgray);
bar(160,120,500,250);
setfillstyle(solidfill,green);
setrgbpalette(green,0,0,0);
bar(420,160,480,220);
setcolor(white);
rectangle(419,159,481,221);
setcolor(white);
outtextxy(436,148,'Renk');
setcolor(blue);
outtextxy(435,147,'Renk');
setfillstyle(solidfill,darkgray);
bar(170,150,302,160);
bar(170,180,302,190);
bar(170,210,302,220);
setcolor(white);
rectangle(170,150,302,160);
rectangle(170,180,302,190);
rectangle(170,210,302,220);
setcolor(white);
outtextxy(171,141,'Kirmizi');
outtextxy(171,171,'Yesil');
outtextxy(171,201,'Mavi');
setcolor(blue);
outtextxy(170,140,'Kirmizi');
outtextxy(170,170,'Yesil');
outtextxy(170,200,'Mavi');

setcolor(white);
setfillstyle(solidfill,blue);
bar(328,150,331,150);
bar(328,180,331,180);
bar(328,210,331,210);

outtextxy(311,151,'Deger:');
outtextxy(311,181,'Deger:');
outtextxy(311,211,'Deger:');
setcolor(blue);
outtextxy(310,150,'Deger:');
outtextxy(310,180,'Deger:');
outtextxy(310,210,'Deger:');
setfillstyle(solidfill,lightgray);
bar(180,135,230,141);
end;

procedure slider(x,y:integer);
begin
setfillstyle(solidfill,green);
bar(x,y,x+5,y+15);
setcolor(white);
rectangle(x,y,x+5,y+15);
line(x+2,y,x+2,y+15);
Size := ImageSize(100,100,105,115);
GetMem(P, Size); { Get memory from heap }
GetImage(100,100,105,115,P^);
setfillstyle(solidfill,black);
bar(100,100,105,115);
end;

procedure getbackgroundr(x,y,z,q:integer);
begin
Size := ImageSize(x,y,z,q);
GetMem(r, Size); { Get memory from heap }
GetImage(x,y,z,q,r^);
end;

procedure getbackgroundg(x,y,z,q:integer);
begin
Size := ImageSize(x,y,z,q);
GetMem(g, Size); { Get memory from heap }
GetImage(x,y,z,q,g^);
end;

procedure getbackgroundb(x,y,z,q:integer);
begin
Size := ImageSize(x,y,z,q);
GetMem(b, Size); { Get memory from heap }
GetImage(x,y,z,q,b^);
end;

procedure sil(x,y:integer);
begin
setfillstyle(solidfill,black);
bar(x,y,x+10,y+10);
end;


begin
clrscr;
grafik;
settextstyle(1,horizdir,4);
setcolor(white);
outtextxy(20,30,'Artik VGA ile renk semek ook kolay');
setcolor(red);
outtextxy(19,29,'Artik VGA ile renk semek ook kolay');
sil(65,32);
setcolor(darkgray);
settextstyle(defaultfont,horizdir,1);
outtextxy(40,400,'Bu program Cenk TARHAN tarafindan programlama'
+' sanati eki icin yapilmistir');
setcolor(green);
outtextxy(39,399,'Bu program Cenk TARHAN tarafindan programlama'
+' sanati eki icin yapilmistir');
sil(265,389);
sil(445,389);
sil(580,389);
sil(610,389);

palet;
slider(100,100);
rx:=0;gx:=0;bx:=0;
repeat

getbackgroundr(rx*2+170,150,rx*2+175,165);
putimage(rx*2+170,150,p^,normalput);
getbackgroundg(gx*2+170,180,gx*2+175,195);
putimage(gx*2+170,180,p^,normalput);
getbackgroundb(bx*2+170,210,bx*2+175,225);
putimage(bx*2+170,210,p^,normalput);
setcolor(black);
str(rx,s);
outtextxy(360,150,s);
str(gx,s);
outtextxy(360,180,s);
str(bx,s);
outtextxy(360,210,s);

kp:=readkey;
setfillstyle(solidfill,lightgray);
bar(360,150,383,160);
bar(360,180,383,190);
bar(360,210,383,220);

          putimage(rx*2+170,150,r^,normalput);
          putimage(gx*2+170,180,g^,normalput);
          putimage(bx*2+170,210,b^,normalput);

 case kp of
     'q' : begin
           rx:=rx-1;end;
     'e' :
                begin
           rx:=rx+1;end;
      'w' : rx:=32;
     's' : gx:=32;
    'x' : bx:=32;
     'a' : begin
           gx:=gx-1;end;
     'd' :
                begin
           gx:=gx+1;end;
     'z' : begin
           bx:=bx-1;end;
     'c' :
                begin
           bx:=bx+1;end;
     end;

 if rx<0 then rx:=0;
 if rx>63 then rx:=63;
 if bx<0 then bx:=0;
 if bx>63 then bx:=63;
 if gx<0 then gx:=0;
 if gx>63 then gx:=63;
 setrgbpalette(green,rx,gx,bx);



until kp=char(27);

closegraph;
end.