;  Tampon bykl 32kb olarak belirlenmitir.
;  Bu byklk Max 64kb 'ta kadar arttrlabilir.

TamponUzun      equ 8000h            ;Buffer'in bayt olarak uzunluu 
tamponYari      equ tamponuzun/2     ;buffer'in yar uzunluu

;burada tanmlanan sabitler Rom Bios data alannda ilgili bilgilerin offsetleridir
Row             equ 484h             ;max. satr says-1 
Col             equ 44ah             ;max. sutun says
mode            equ 449h             ;ekran modu

Color           equ 0B800h           ;renkli video belleinin segment adresi
Mono            equ 0B000h           ;mono video belleinin segment adresi
yigit_uzun      equ 100h             ;Stack uzunluu   
yan_kayma_mik   equ 10               ;sa ve sol tularda yanlara kayma mik.

	
	jumps
	locals @@
Cseg    segment
	assume cs:cseg,ds:cseg,es:cseg,ss:cseg
ExeBoyTaban Label Word
Viewbasi:
	cli                                     ;interruptlar kapa       
	Mov     ax,cs                           ;AX=CS
	Mov     ss,ax                           ;SS=AX
	mov     sp,offset yigit+yigit_uzun      ;SP=yeni stack
	sti                                     ;interruptlar a
	Mov     ds,ax                           ;DS=Ax
	Mov     Psp_Seg,es                      ;PSP_SEG = psp adresi 
	Mov     Es,ax                           ;ES=AX
	Call    Hazirlik                        ;ilk ilemler
	jb      prgcik                          ;dosya alamad ise bitti
	mov     ds,cs:bufferseg                 ;DS=text'in okunduu seg.
	call    sayfaprint                      ;ilk sayfay gster.
Tus_al:                                         ; ****ANA DNG*****
	xor     ax,ax                           ;AX=0
	int     16h                             ;Klavyeden tu al.
	cmp     al,27                           ;ESC tuuna basld ise 
	jz      menucik                         ;               ka git
	cmp     ax,5100h                        ;pagedown tuuna basld ise
	jz      pagedown                        ;
	cmp     ax,4900h                        ;pageup tuuna basld ise
	jz      pageup                          ;
	cmp     ax,5000h                        ;aa ok tuuna basld ise
	jz      Tusdown                         ;
	cmp     ax,4800h                        ;yukar ok tuuna basld ise
	jz      Tusup                           ;
	cmp     ax,4700h                        ;home tuuna basld ise
	jz      Tushome                         ;
	cmp     ax,4f00h                        ;end tuuna basld ise
	jz      Tusend                          ;
	cmp     ax,4b00h                        ;sol ok tuuna basld ise
	jz      tusleft                         ;
	cmp     ax,4d00h                        ;sa ok tuuna basld ise
	jz      tusright                        ;
	jmp     tus_al                          ;

Tusleft:                                ;>>>SOL ok tuuna basld ise.<<<
	cmp     byte ptr cs:ilksutun,1  ;eer ilksutun  
	jz      tus_al                  ;pencerenin ilk sutununa eit ise  sola gidilemez.
	sub     cs:ilksutun,yan_kayma_mik ; 
	sub     cs:sonsutun,yan_kayma_mik ; 
	mov     cl,cs:Satirsayisi       ;
	xor     ch,ch                   ;
	sub     cl,4                    ;CX=pencerede gsterilen satr says
donaw1:                                 ;
	call    geri_satir_bul          ;normalde SI bir sonraki sayfay iaret eder.
	loop    donaw1                  ;bu nedenle geri gidilerek ekrandaki textin ilk satrn adresi
	call    sayfaprint              ;bulunarak sayfa tekrar gsterilir. 
	jmp     tus_al                  ;i bitti tekrar tu almaya git.



tusright:                               ;>>>SA ok tuuna basld ise.<<<
	cmp     cs:ilksutun,200         ;pencerenin ilksutun pen_x+200 den
	ja      tus_al                  ;byk ise saa gidilemez.
	add     cs:ilksutun,yan_kayma_mik
	add     cs:sonsutun,yan_kayma_mik         
	mov     cl,cs:satirsayisi       ;
	xor     ch,ch                   ; 
	sub     cl,4                    ;CX=pencerede gsterilen satr says
donbw1:                                 ;
	call    geri_satir_bul          ;normalde SI bir sonraki sayfay iaret eder.
	loop    donbw1                  ;bu nedenle geri gidilerek ekrandaki textin ilk satrn adresi 
	call    sayfaprint              ;bulunur ve sayfa tekrar gsterilir.
	jmp     tus_al                  ;i bitti tekrar tu almaya git.

TusHome:                                ;>>>HOME tuuna basld ise.<<<
	cmp     cs:dosya_basi,1         ;dosya_basi=1 ise zaten dosya bandayz
	jz      tus_al                  ;ilem yapmadan geri git.
	mov     cs:konuml,ilkkonum      ;dosyann bandan okuma iin konuml ve
	mov     cs:konumh,0             ;konumh sfrlanr
	mov     dx,0                    ;dx'e okumann yaplaca yer, yani tamponun adresi verilir.
	mov     cx,tamponuzun           ;cx'e okuma miktar,yani tampon uzunluu verilir.
	call    dosyadan_oku            ;bu bilgiler nda dosyadan oku
	mov     si,0                    ;sayfa gstergeci ilk sayfaya ayarlanr.
	mov     cs:dosya_basi,1         ;dosya banda olduumuzu belirtelim.
	call    sayfaprint              ;bir sayfa ekrana getir.
	mov     cs:dosya_sonu,0         ;imdilik dosya_sonu=0
	cmp     si,cs:okunan            ;u anki konum okunandan byk veya eitse
	jb      dosyasondeg             ;dosya sonudur.dosya_sonu=1 
	mov     cs:dosya_sonu,1         ;yoksa daha dosyada okunacak data var
dosyasondeg:        
	jmp     tus_al                  ;i bitti tekrar tu almaya git.


tusEnd:                                 ;>>>END tuuna basld ise.<<<
	cmp     cs:dosya_sonu,1         ;dosya_sonu=1 ise bu ileme gerek yok
	jz      tus_al                  ;ilem iptal. geri dn.  
	mov     bx,cs:kutukno           ;BX'e kutuk tantcsn koy.
	xor     cx,cx                   ;CX=0
	xor     dx,dx                   ;DX=0
	mov     ax,4202h                ;okuma kafasn dosyann sonuna gtr
	int     21h                     ;dolays ile ilem sonunda DX:AX dosyann uzunluunu verir.
	mov     cs:konuml,ax            ;Konuml ve konumh deikenleri
	mov     cs:konumh,dx            ;dosya sonunu gsterir ekilde ayarlanr
	cmp     dx,0                    ;eer dosya 64k'dan bykse
	ja      yeterli                 ;yeterli'ye git
	cmp     ax,tamponuzun           ;dosya tampon uzunluundan
	ja      yeterli                 ;bykse yeterli'ye git
	mov     cs:konuml,ilkkonum      ;yoksa dosya bandan 
	mov     cs:konumh,0             ;itibaren okunacak
	jmp     yeteratla
yeterli:                                ;dosyann boyu tampondan bykse
	sub     cs:konuml,tamponuzun    ;dosya sonundan tampon uzunluu
	sbb     cs:konumh,0             ;kadar geriden okunacak
yeteratla:        
	mov     dx,0                    ;DX=verinin okunaca adres
	mov     cx,tamponuzun           ;CX=okunacak bayt miktar
	call    dosyadan_oku            ;ve dosyadan oku,oku adam ol benim gibi eek olma
	mov     cl,cs:satirsayisi       ;
	xor     ch,ch                   ;CX=penceredeki satr says
	sub     cl,3                    ;cizgiler iin 2 kar.
	cmp     cs:okunan,-1            ;eer istenildii kadar okuma yaplamamsa
	jb      atlak                   ;SI=okunan verinin sonu
	mov     si,tamponuzun           ;okuma tamsa SI=tampon sonu
	jmp     atlaj                   ;Atlaj'a  git.
atlak:        
	mov     si,cs:okunan            ;SI=tampon ba+okunan miktar
atlaj:        
	call    geri_satir_bul          ;
	loop    atlaj                   ;bir sayfa geri bul
	push    si
	call    sayfaprint              ;ve o sayfay ekrana getir
	mov     cs:dosya_sonu,1         ;artk dosyann sonundayz.
	mov     cs:dosya_basi,0         ;imdilik dosya_basi=0
	pop     ax
	cmp     ax,0                    ;satr tamponun bandan bykse
	ja      basdegil                ;dosya ba deil
	mov     cs:dosya_basi,1         ;yoksa dosya bandayz.
basdegil:        
	jmp     tus_al                  ;ilem tamam.geriye... 


pageup:                                 ;>>>PAGE UP tuuna basld ise.<<< 
	cmp     cs:dosya_basi,1         ;dosyann banda isek bu ileme
	jz      tus_al                  ;gerek yok.tekrar tu al.
	mov     cl,cs:satirsayisi       ;
	xor     ch,ch                   ;CX=penceredeki satr says
	sub     cl,4                    ;alt,st izgileri kar.
	shl     cx,1                    ;2'ye katla.neden ?.nk SI bir sonraki sayfay 
donw1:                                  ;iaret ediyor.bir sayfa geri alnnca ayn sayfa bulunur.
	call    geri_satir_bul          ;bu nedenle 2 sayfa geri alnarak bir nceki 
	loop    donw1                   ;sayfann ban buluruz.
	call    sayfaprint              ;Bulunan sayfa ekrana getirilir.
	mov     cs:dosya_sonu,0         ;imdilik dosya_sonu=0
	cmp     si,cs:okunan            ;eer si okunandan byk veya eit ise 
	jb      dosyasondur1            ;dosya sonundayz.
	mov     cs:dosya_sonu,1         ;yoksa dosya sonuna daha var.
dosyasondur1:        
	jmp     tus_al                  ;bu ilemide bitirdik.geriye..

pagedown:                               ;>>>PAGE DOWN tuuna basld ise<<<
	cmp     cs:dosya_sonu,1         ;kardeim dosyann sonuna gelmisin  
	jz      tus_al                  ;daha nereye gitmek istiyorsun. 
	mov     cl,cs:satirsayisi       ;CX=penceredeki satr says
	sub     cl,3                    ;alt-st izgileri kar
	xor     ch,ch                   ;
	push    cx                      ;satr adedini sakla
donbedon:                               ;*burada ne kadar ileri gidebileceimizi
	call    ileri_satir_bul         ;test ediyoruz. 
	jb      donbecikti              ;eer CF=1 dosya sonuna geldik.
	loop    donbedon                ;cx sfr olana kadar dn
	jmp     bura                    ;dosya sonuna daha gelmemiiz.
donbecikti:                             ;CF=1 olduundan dngden kld
	mov     cs:dosya_sonu,1         ;CF=1 ise dosya sonuna geldik
bura:                                   ;
	pop     cx                      ;penceredeki toplam satr kadar 
donbedon1:                              ;geri gideceiz.
	call    geri_satir_bul          ;cx'teki miktar kadar geri satr bul
	loop    donbedon1               ;
	push    si                      ;
	call     sayfaprint             ;sayfay ekrana getir.
	mov     cs:dosya_basi,0         ;imdilik dosya_basi=0
	pop     ax                      ;
	cmp     ax,0                    ;ekrana getirilen sayfa tampon
	ja      basdegil1               ;basindan bykse dosya basnda deiliz
	mov     dosya_basi,1            ;yoksa dosyann banda bulunuyoruz.
basdegil1:        
	jmp     tus_al
      


Tusdown:                                ;>>>DOWN tuuna basld ise.<<<
	cmp     cs:dosya_sonu,1         ;dosya sonunda isek geri dn
	jz      tus_al
	call    ileri_karakter_bul      ;tamponda veya dosyada karakter varm 
	pushf                           ;sonucu sakla
	call     geri_karakter_bul      ;gstergeci geri al
	popf                            ;
	jb      tus_al                  ;baka karakter yok.ilem iptal edildi 
	mov     ax,0601h                ;    
	mov     bh,cs:Renk              ;  bh'ta rengi,
	mov     ch,1                    ;    ch'ta st sol satr
	inc     ch                      ;
	mov     cl,0                    ;       cl'de sol st sutunu
	inc     cl                      ; 
	mov     dh,cs:satirsayisi                  
	sub     dh,3
	mov     dl,cs:sutunsayisi       ;           dl'de sa alt sutunu
	dec     dl                        
	dec     dl                      ;            bulunan pencereyi
	int     10h                     ;  bir yukar kaydr.
	mov     al,cs:satirsayisi       ;  AL=toplam satr says
	sub     al,3                    ;  
	push    ax                      ;
	call    satirprint              ; yeni satr yaz.
	mov     cs:dosya_basi,0         ; imdilik dosya basnda olduunuzu dnyoruz
	cmp     si,0                    ; gstergec tampon bandan  
	ja      basdegil2               ; bykse dosya banda deiliz
	mov     cs:dosya_basi,1         ; yoksa dosya bandadr.
basdegil2:                              ;
	jmp     tus_al                  ; i bitti. geriye..

TusUp:                                  ;>>>UP tusuna basld ise.<<<<
	cmp     cs:dosya_basi,1         ;dosya banda isek 
	jz      tus_al                  ;  tekrar tu almaya git
	mov     cl,cs:satirsayisi       ;cl=penceredeki satr says
	xor     ch,ch                   ;ch=0
	dec     cl                      ;(top.satr-2)+1 kadar yukar satr bul
	push    cx                      ; 
donw2:                                  ;
	call    geri_satir_bul          ;
	loop    donw2                   ;
	mov     ax,0701h                ; aa scroll
	mov     bh,cs:Renk              ; aa kan satrn rengi
	mov     ch,1                    ;st sol satr
	inc     ch                      ;
	mov     cl,0                    ; st sol sutun
	inc     cl                      ;
	mov     dh,cs:satirsayisi       ; alt sa satr
	sub     dh,3
	mov     dl,cs:sutunsayisi       ; alt sa sutun
	dec     dl                         
	dec     dl
	int     10h                     ; kaydr.
	mov     al,2                    
	push    ax
	call     satirprint             ; yaz.
	pop     cx                      ;
	sub     cx,2                    ;
donw3:                                  ;
	call    ileri_satir_bul         ;si yazmacn ileriki sayfann
	loop    donw3                   ;bana ayarla
	mov     cs:dosya_sonu,1         ;imdilik dosya_sonu=1
	cmp     si,cs:okunan            ;okunan
	jae     dosyasondur2            ;gstergeten byk veya eitse
	mov     cs:dosya_sonu,0         ;dosya sonundayz
dosyasondur2:                           ;deilse daha data var.
       jmp      tus_al                     ;
					   
menucik:                                   ;ESC tuuna basld ise
	mov     bx,cs:kutukno              ;BX=kutuk tantcs
	mov     ah,3eh                     ;kutuu kapat. 
	int     21h                        ;
prgcik:                                    ;
	mov     cs:renk,7                  ; Prizma
	mov     ah,0                       ;       Turkish
	call    ekransil                   ;            amatour
	lea     dx,pmsg                    ;                  programers
	push    cs                         ;                          group
	pop     ds                         ; Recep
	mov     ah,9                       ;       Hasan
	int     21h                        ;             A.Serdar
	mov     ah,4ch                     ;                    Semih
	int     21h                        ;          Bitti.





pencere proc near
	push    bx cx dx si di es               ;
	mov     ah,0                            ;  tm 
	mov     bh,cs:renk                      ;      ekran
	call    ekransil                        ;            temizle
	mov     ah,2                            ;  st 
	mov     bh,70h                          ;      bant
	mov     bl,0                            ;           ciz         
	call    ekransil                        ;             
	mov     ah,2                            ;  alt 
	mov     bh,70h                          ;      bant
	mov     bl,cs:satirsayisi               ;           ciz
	dec     bl                              ;                     
	call    ekransil                        ;
	mov     ah,2                            ;
	mov     bh,0                            ;       
	mov     dx,100h                         ;    
	int     10h                             ; c             
	mov     ah,9                            ;  e
	mov     al,''                          ;   r 
	mov     bl,cs:renk                      ;    c   
	xor     bh,bh                           ;     e        
	mov     cl,cs:sutunsayisi               ;      v
	dec     cl                              ;       e
	mov     ch,bh                           ;
	int     10h                             ;
	mov     ah,2                            ;           c
	mov     bh,0                            ;            i
	mov     dl,0                            ;             z
	mov     dh,cs:satirsayisi               ;               
	sub     dh,2                            ;              
	int     10h                             ;              
	mov     ah,9                            ;c              
	mov     al,''                          ; e
	mov     bl,cs:renk                      ;  r        
	xor     bh,bh                           ;   c
	mov     cl,cs:sutunsayisi               ;    e
	dec     cl                              ;     v
	mov     ch,bh                           ;      e
	int     10h                             ;
	mov     cl,cs:satirsayisi               ;
	xor     ch,ch                           ;          c
	sub     cx,4                            ;           i
	mov     es,cs:ekranseg                  ;            z
	mov     al,cs:sutunsayisi               ;
	xor     ah,ah                           ;
	mov     si,ax                           ;
	shl     si,1                            ;
	xor     di,di                           ;
	add     di,si                           ; c
	mov     ah,cs:renk                      ;  e
	mov     al,''                          ;   r
	mov     es:[di],ax                      ;    c
	mov     ah,cs:renk                      ;     e
	mov     al,''                          ;      v
	add     di,si                           ;       e
	mov     es:[di-2],ax                    ;
@@dongu:                                        ;
	mov     ah,cs:renk                      ;           c
	mov     al,''                          ;            i
	mov     es:[di],ax                      ;             z
	mov     ah,cs:renk                      ;
	mov     al,''                          ;
	add     di,si                           ;
	mov     es:[di-2],ax                    ; c
	loop    @@dongu                         ;  e
	mov     ah,cs:renk                      ;   r
	mov     al,''                          ;    c
	mov     es:[di],ax                      ;     e
	mov     ah,cs:renk                      ;      v
	mov     al,''                          ;       e
	add     di,si                           ;
	mov     es:[di-2],ax                    ;
	pop     es di si dx cx bx               ;           c
	ret                                     ;            i
pencere endp                                    ;             z




sayfaprint proc near  
	push    bp cx                           ;yazmalar sakla
	mov     ah,1                            ;view penceresinin 
	mov     bh,cs:Renk                      ;           iini
	call    ekransil                        ;                temizle
	mov     bp,2                            ;BP=pencerenin ilk satr
	mov     cl,cs:satirsayisi               ;max. satr says
	xor     ch,ch                           ;
	sub     cx,3                            ;penceredeki max.satr says 
@@geri:                                         
	push    bp                              ;satr no --> stack'a     <-+
	call    satirprint                      ;satr ekrana getir.       |
	inc     bp                              ;BP=BP+1                    |
	cmp     bp,cx                           ;daha yazlacak satr varsa +
	jbe     @@geri                          ;
	pop     cx bp                           ;yazmalar dzelt 
	ret                                     ; geri dn
sayfaprint endp




SatirPrint proc pascal sat:byte
	push    bx cx di es                     ;yazmaclar sakla
	Mov     es,cs:ekranseg                  ;ES=video belleinin seg.
	mov     al,sat                          ;AL=yazlacak satr no
	call    satlocate                       ;al'deki satrn video bellek
	mov     di,ax                           ;teki offseti DI'ye verilir
	mov     bl,1                            ;Bl=ilk sutun
@@kar_al:                                       ;
	call    ileri_karakter_bul              ;bufferden karakter al
	jb      @@bitti                         ;CF=1 ise dosya sonu
	cmp     al,9                            ;TAB ise  ekrana
	jnz     @@d1                            ;
	mov     cx,8                            ;8 adet space yaz.
	mov     al,32                           ;
	jmp     @@yazdon                        ;
@@d1:                                           ;
	cmp     al,13                           ;enter ise tekrar kar. al.
	jz      @@kar_al                        ;
	cmp     al,10                           ;alt satr ise  
	jz      @@bitti                         ;           satr sonu.
	mov     cx,1                            ;
@@yazdon:                                       ;
	cmp     bl,cs:ilksutun                  ; 
	jb      @@sutunatla                     ;
	cmp     bl,cs:sonsutun                  ;
	jae     @@sutunatla                     ;
	mov     ah,cs:Renk                      ;
	stosw                                   ;
@@sutunatla:                                    ;
	inc     bl                              ;
	loop    @@yazdon                        ;
	jmp     @@kar_al                        ;
@@bitti:                                        ;
	pop     es di cx bx                     ;
	ret                                     ;
satirprint endp                                 ;
	

Dosya_ac proc near                    
	Mov     es,cs:psp_seg                   ;cevre bloundan
	mov     es,es:[2ch]                     ;        alan 
	xor     di,di                           ;             dosyann
@@geri:                                         ;       
	cmp     word ptr es:[di],0              ; yolu+isminin
	jz      @@Buldu                         ;           offsetini 
	inc     di                              ;                al.
	jmp     @@geri                          ;
@@buldu:                                        ;
	add     di,4                            ;
	push    es                              ;
	pop     ds                              ;
	mov     dx,di                           ;
	mov     ax,3d00h                        ; dosyay a.
	int     21h                             ;
	push    cs
	pop     ds                      
	jnc     @@acildi                
	stc                             
	ret                             
@@acildi:                               
	mov     cs:kutukno,ax              
	mov     bx,ax
	mov     cs:konuml,IlkKonum              ;
	mov     cs:konumh,0                     ;
	Mov     bx,offset Son___adres + yigit_uzun
	mov     cl,4
	shr     bx,cl
	inc     bx
	mov     ax,cs
	add     bx,ax
	mov     cs:BufferSeg,bx
	xor     dx,dx
	mov     cx,tamponuzun           
	call    dosyadan_oku            
	xor     si,si
	mov     cs:dosya_basi,1            
	ret                             
Dosya_ac endp


	
;============================================================================
;EkranSil
;Ah=0 tm ekran 
;AH=1 st ve alt'tan 2'er satir- sa ve sol'da bir sutun haric pen. sil
;Ah > 1 satr sil  bl=satrno
;bh=attr
;============================================================================
EkranSil Proc near        
	Push    es cx dx di si
	Mov     Es,cs:EkranSeg
	cmp     ah,0
	jnz     @@D1
	Xor     Ax,Ax                
	Mov     Al,cs:SutunSayisi       
	Xor     Cx,Cx                
	Mov     Cl,cs:SatirSayisi       
	Inc     Cx                   
	Mul     Cx                   
	mov     cx,ax
	Xor     Di,Di                
	mov     Ah,bh
	mov     al,32
	cld
	rep     stosw
	jmp     @@cik
@@d1:        
	cmp     ah,1
	jnz     @@d2
	Xor     dx,dx                
	Mov     dl,cs:SutunSayisi       
	mov     si,dx
	sub     dx,2         
	Xor     Cx,Cx                
	Mov     Cl,cs:SatirSayisi       
	sub     cx,4                
	shl     si,1
	cld
	mov     al,32        
	mov     ah,bh
	mov     di,0
	add     di,si
	add     di,si
@@geri:        
	add     di,2         
	push    cx
	mov     cx,dx
	rep     stosw     
	pop     cx
	add     di,2
	dec     cx
	jnz     @@geri
	jmp     @@cik
@@d2:        
	Xor     Ax,Ax                
	Mov     Al,cs:SutunSayisi       
	push    ax
	Shl     Ax,1                 
	mov     cl,bl
	xor     ch,ch
	mul     cx
	mov     di,ax
	pop     cx
	mov     ah,bh
	mov     al,32
	cld
	rep     stosw
@@cik:          
	pop     si di dx cx es
	ret
EkranSil endp




Hazirlik proc near
	push    Es
	Xor     Ax,Ax                
	Mov     Es,Ax                
	Mov     Al,Byte Ptr Es:[Row] 
	inc     Al
	Mov     cs:SatirSayisi,Al       
	Mov     Al,Byte Ptr Es:[Col] 
	Mov     cs:SutunSayisi,al       
	Mov     Bx,Mono
	Mov     Al,Byte Ptr Es:[Mode]
	Cmp     Al,7                 
	Jz      MonoEkr              
	Mov     Bx,Color              
MonoEkr:
	mov     cs:ekranseg,bx         
	mov     cs:ilksutun,1
	mov     al,cs:sutunsayisi
	dec     al
	mov     cs:sonsutun,al
	mov     cs:dosya_basi,0
	mov     cs:dosya_sonu,0
	pop     es
	Call    Dosya_ac
	call    pencere
	push    es di ds si cs
	pop     ds
	lea     si,menu_str
	mov     es,cs:ekranseg
	mov     al,cs:satirsayisi
	dec     al
	call    satlocate
	mov     di,ax
	mov     ah,70h
geri:        
	lodsb   
	or      al,al
	jz      bit
	stosw
	jmp     geri
bit:        
	pop     si ds di es
	ret
Hazirlik endp



satLocate proc near  ;AL = satr
	push    dx cx 
	xor     ah,ah
	xor     ch,ch
	mov     cl,cs:sutunsayisi
	shl     cx,1
	mul     cx
	add     ax,2
	pop     cx dx
	ret
satLocate endp


dosyadan_oku proc near
	push    ax bx cx dx
	mov     cs:okunan,-1            ;okunan'a bir word'n alabilecei max deer verilir
	mov     dx,cs:konumL            ;data okunacak konum
	mov     cx,cs:konumH
	mov     bx,cs:kutukNo
	mov     ax,4200h                ;ayarlanr.        
	int     21h
	pop     dx cx                   ;DS:DX'teki adrese CX'teki say kadar bayt
	push    ds
	Mov     ds,cs:bufferseg
	mov     ah,3Fh                  ;okunur.       
	int     21h
	pop     ds
	jnc     @@okundu                ;okuma baarl ise okundu'ya git
	xor     ax,ax                   ;baarsz ise AX=0
@@okundu:
	cmp     ax,cx                   ;okunan miktar okunacak miktar ile  
	jz      @@esit                  ;ayn ise esit'e git
	add     ax,dx                   ;AX(okunulan miktar)=AX+DX(okunulacak adres)
	mov     cs:okunan,ax            ;datann tampondaki son adresi
@@esit: 
	pop     bx ax 
	ret
dosyadan_oku endp





ileri_satir_bul proc near  
	call    ileri_karakter_bul              ;Tampondan bir sonraki 
						;karakteri al                
	jb      @@hata                          ;eer CF=1 karakter alamadan 
						;dosya sonuna ulatk
@@geri:
	call    ileri_karakter_bul              ;tampondan bir sonraki 
						;karakteri al            
	jb      @@tekrar1                       ;dosya sonuna gelindiyse 
						;tekrar1'e git
	cmp     al,10                           ;alnan karakter satr sonu 
						;deilse 
	jnz     @@geri                          ;aramaya devam 
	clc                                     ;satr ba bulundu
	ret                                     ;hata yok dn CF=0
@@hata:
	stc                                     ;dosya sonu  hata CF=1
	ret                                     ;dn
@@tekrar1:
	call    Geri_karakter_bul               ;bir miktar ilerledikten sonra             
	jb      @@geri_gidilemez                ;dosya sonuna ulaldysa 
	cmp     al,10                           ;nceki 
	jnz     @@tekrar1                       ;  satrn bana git
	call    ileri_karakter_bul              ;  ve hata vererek dn             
@@geri_gidilemez:
	stc
	ret
ileri_satir_bul endp

Geri_satir_bul  proc near       
	call   Geri_karakter_bul                ;tampondan bir nceki 
						;karakteri  al           
	jb     @@geri_gidilemez                 ;olmuyorsa dosya bana 
						;gelinmi
@@tekrar1:
	call   Geri_karakter_bul                ;geri bir karakter al             
	jb     @@geri_gidilemez                 ;olmuyorsa dosya bana gelinmi 
	cmp    al,10                            ;bulunan karakter satr ba
	jnz    @@tekrar1                        ;deilse tekrar et
	call   ileri_karakter_bul               ;satr ba bulundu ve bir ileri             
	clc                                     ;giderek satrn bana gel. 
	ret                                     ; hata yok  dn
@@geri_gidilemez:
	stc                                     ;CF=1 hata
	ret                                     ; dn
Geri_satir_bul   endp




Geri_karakter_bul proc near        
	push    ds                              ;
	mov     ds,cs:bufferseg                 ;
	cmp     si,0                            ;karakter alnacak yer
	ja      @@tam_tam                       ;tamponun bandan bykse kar.almaya git
	mov     ax,cs:konumL                    ;
	mov     bx,cs:konumH                    ; dosyann konumu
	cmp     bx,0                            ;
	ja      @@byk                           ;
	cmp     ax,ilkkonum                     ;
	jbe     @@dosya_basi                    ; dosya bandayz **hata**
						;
@@byk:                                          ;
	push    di cx dx ds                     ;
	pop     es                              ;dosya basnda deilsek
	cmp     word ptr cs:konumh,0            ;
	ja      @@atla1                         ;
	cmp     word ptr cs:konuml,tamponyari   ;
	ja      @@atla1                         ;
	mov     si,0                            ;
	mov     word ptr cs:konuml,ilkkonum     ;
	mov     word ptr cs:konumh,0            ;
	mov     cx,tamponuzun                   ;
	jmp     @@atla2                         ;
@@atla1:                                        ;
	mov     si,0                            ;
	mov     di,tamponyari                   ;tamponun st yarsn
	mov     cx,tamponyari                   ;alt yarya kopyala
	cld                                     ;
	rep     movsb                           ;
	sub     word ptr cs:konumL,tamponyari   ;okunacak konumu ayarla
	sbb     word ptr cs:konumH,0            ;
	mov     cx,tamponyari                   ;okunacak bayt adedi
@@atla2:                                        ;
	mov     dx,0                            ;datann aktarlaca adresi
	call    dosyadan_oku                    ;Oku
	pop     dx cx di                        ;
	jmp     @@tam_tam                       ; artk karakter alnabilir
@@dosya_basi:                                   ;
	mov     cs:dosya_basi,1                 ; dosya bana geldik
	stc                                     ; CF=1     hata
	pop     ds                              ;
	ret                                     ; dn
@@Tam_Tam:                                      ;
	dec     si                              ; SI=SI-1
	mov     al,[si]                         ; al'ye DS:SI'den bir bayt al
	pop     ds                              ;
	clc                                     ; CF=0 hata yok
	ret                                     ;dn
geri_karakter_bul endp





ileri_karakter_bul proc near        
	cmp     si,cs:okunan                    ;karakter alacamz adres
	jae     @@dosyason                      ;okunandan bykse dosya sonu 
	cmp     si,tamponuzun                   ;tamponu amam ise
	jb      @@tamam                         ;karakter alnabilir yoksa
	push    di cx dx es ds                  ;tamponun alt yarsn
	mov     ds,cs:bufferseg                 ;
	push    ds                              ;
	pop     es                              ;
	mov     si,tamponyari                   ;tamponun alt yarsn
	mov     di,0                            ;tamponun st blmne
	mov     cx,tamponyari                   ;
	cld                                     ;
	rep     movsb                           ;     kopyala
	mov     si,di                           ;SI=kalnan son adres
	add     word ptr cs:konumL,tamponuzun   ;dosyadan okunacak yerin
	adc     word ptr cs:konumH,0            ;konumu hesaplanr.
	mov     dx,tamponyari                   ;DX=datann konulaca adres
	mov     cx,tamponyari                   ;CX=okunulacak bayt adedi
	call    dosyadan_oku                    ;oku
	sub     word ptr cs:konumL,tamponyari   ;konum tamponun st olarak
	sbb     word ptr cs:konumH,0            ;braklr.
	pop     ds es dx cx di                  ;
	jmp     ileri_karakter_bul              ;tekrar kontrole git
@@tamam:                                        ;
	push    ds                              ;
	mov     ds,cs:bufferseg                 ;
	lodsb                                   ;al'ye DS:SI'den bir kar. al
	pop     ds                              ;
	clc                                     ;CF=0  hata yok
	ret                                     ; dn
@@dosyason:                                     ;
	mov     cs:dosya_sonu,1                 ;Dosya sonuna gelindi 
	stc                                     ;CF=1  hata
	ret                                     ;dn
ileri_karakter_bul endp

SatirSayisi     Db ?                    ;satr saysnn saklanaca alan
SutunSayisi     Db ?                    ;sutun saysnn saklanaca alan   
BufferSeg       dw ?
kutukno         dw ?                    ;kutuk tantcsnn sakland yer
konuml          dw ?                    ;buffer'daki verinin dosyadaki konumu
konumh          dw ?                    ;Konuml dk word',konumh yksek word' 
okunan          dw ?                    ;normalde -1,buffer dolmamsa okunan bayt miktar
ilksutun        db ?                    ;text'in ekrana getirilecek ilk sutunu
sonsutun        db ?                    ;text'in ekrana getirilecek son sutunu
Renk            db 17h                  ;pencere rengi (n renk+arka renk*16)
dosya_basi      db ?                    ;1 ise dosya bandayz
dosya_sonu      db ?                    ;1 ise dosya sonundayz
ekranseg        dw ?
psp_seg         dw ?
Menu_Str        db'Kontrol : ',27,24,25,26,' PgUp PgDown Home End     k= ESC',0
pMsg    db 13,10,9,9,'               Prizma  '
	db 13,10,9,9,"      Turkish Amateur Programmers' Group"
	db 13,10,9,9,' TXT2EXE, executable text file maker. (c) 1994' 
	db 13,10,9,9,"          Coded by Recep Tezkol"  
	db 13,10,9,9,'       Call us, we are waiting...$'
yigit:  
Son___adres:
ExeBoy          equ $-ExeBoyTaban
ilkkonum        equ exeboy + 512
cseg    ends
	end viewbasi
