#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>

union REGS inregs,outregs;
struct SREGS segregs;
int iks,ye,dugme;

void acfare(void) // Fareyi ilk kullanma hazrlar. (Fare a deildir, ben faremi iyi beslerim)
{
  inregs.x.ax = 0;
  int86x(0x33, &inregs, &outregs, &segregs);
  if (outregs.x.ax==0) {printf("Fare yok.");exit(1);}
}

void gosterfare(void) // Farenin gstergecini ekranda gzkr duruma getirmek iin. (Farem tehirci hi deildir)
{
  inregs.x.ax = 1;
  int86x(0x33, &inregs, &outregs, &segregs);
}

void saklafare(void) // Farenin gstergecini ekrandan yoketmek icin. (Faremin aslnda gizlisi sakls yoktur)
{
  inregs.x.ax = 2;
  int86x(0x33, &inregs, &outregs, &segregs);
}

int okufare(int *x,int *y,int *button) // Fare srcsnn fare hakknda gnderdii bilgileri almak iin. (Benim farem kltrldr, okuma yazmas bile var)
/* Gelen paremetreler farenin ekrandaki x,y kordinatlar ve farenin o anki
  basl bulunan tu bilgisi. Tu bilgisi bit-kodlanmtr.
  00000000
       |||_ sol tu basldysa 1 olur
       ||__ sag tu basldysa 1 olur
       |___ orta tu basldysa 1 olur
  Yani hibir tu basl deilse 0, sol baslysa 1, sa baslysa 2, hem sol
  hem sa baslysa 3 , vs. vs. eklinde deer alr button deikeni.
*/
{
  inregs.x.ax = 3;
  int86x(0x33, &inregs, &outregs, &segregs);
  *x=(int)outregs.x.cx;
  *y=(int)outregs.x.dx;
  *button=(int)outregs.x.bx;
  return *button;
}

void koyfare(int x, int y) // Farenin gstergecini ekranda konumlandrmak iin. (Benim farem aslnda ok terbiyelidir)
{
  inregs.x.ax = 4;
  inregs.x.cx = (unsigned)x;
  inregs.x.dx = (unsigned)y;
  int86x(0x33, &inregs, &outregs, &segregs);
}

void sinirlafare(int x1, int y1,int x2,int y2) // Gstergecin dolaabilecei alan snrlandrmak iin (Benim farem snr tanmaz)
  {
  inregs.x.ax = 7;
  inregs.x.cx = (unsigned)x1;
  inregs.x.dx = (unsigned)x2;
  int86x(0x33, &inregs, &outregs, &segregs);
  inregs.x.ax = 8;
  inregs.x.cx = (unsigned)y1;
  inregs.x.dx = (unsigned)y2;
  int86x(0x33, &inregs, &outregs, &segregs);
  }

void main(void)
{
 acfare(); // fare alr
 gosterfare(); // fare gsterilir (text modunda)
 do {
    okufare(&iks,&ye,&dugme); // veriler alnr
    gotoxy(1,1);printf("x:%3d",iks);gotoxy(7,1);printf("y:%3d",ye); // ekrana yazlr
    gotoxy(13,1);
     switch(dugme) {                     // tu durumu saptanr
	case 0: printf("Bos    ");break; // ekrana yazlr
	case 1: printf("Sol    ");break;
	case 2: printf("Sag    ");break;
	case 3: printf("Sol+Sag");break;
	case 4: printf("Orta   ");break;
		   }
    } while(!kbhit()); // klavye tuu baslana kadar beklenir

 saklafare(); // fare saklanr
 inregs.x.ax = 0x13;
 int86x(0x10, &inregs, &outregs, &segregs);  // grafik ekrana geilir

 getch();
 sinirlafare(20,20,100,100); // fare snrlanr
 koyfare(60,60); // snrn ortasna konur
 gosterfare(); // fare gsterilir (grafik modunda)
	       // yukardaki ilemler aada da tekrarlanr
 do {
    okufare(&iks,&ye,&dugme);
    gotoxy(1,1);printf("x:%3d",iks);gotoxy(7,1);printf("y:%3d",ye);
    gotoxy(13,1);
     switch(dugme) {
	case 0: printf("Bos    ");break;
	case 1: printf("Sol    ");break;
	case 2: printf("Sag    ");break;
	case 3: printf("Sol+Sag");break;
	case 4: printf("Orta   ");break;
		   }
    } while(!kbhit());

 saklafare();

 inregs.x.ax = 3;
 int86x(0x10, &inregs, &outregs, &segregs);

}

