				/*
				Bu program C ve Sistem Programclar Dernei'nin
				am olduu 'Sistem Programlamaya Girive leri C' kursunda
				Grbz Aslan tarafndan anlatlmtr.	*/
				/*      Typing ve Yorum:Deniz mit Kabuli       */

# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <dos.h>
# include <dir.h>

void _file_ (char *fname);
int ftree (char path[]);
unsigned _nfiles=0, _ndirs = 0 ;

void main(int argc, char *argv[])
{
	if(argc != 2)
	{
		fprintf(stderr,"Kullanm:  ftree <path>\n");
		exit (1);
	}
	ftree(argv[1]);
	_file_(" ");
	printf("Dosya Says: %u\nDizin says: %u\n", _nfiles , _ndirs);

	exit (0);
}
int ftree(char path[])
{
	int ret=0;
	char *p, *cpath, *pbuf;
	static char _path[128], _fname [128];   /*static olmas nemli! */
	struct ffblk  *f_inf;   /*      hazr yap(dir.h'da bildirilmi) */
	if(( f_inf=(struct ffblk *) malloc (sizeof(struct ffblk)))==NULL \
		||(cpath=malloc(128))==NULL ||(pbuf=malloc(128))==NULL)
			return -1;
			/*Dinamik bellek ayrma ilemi baarsz ise -1'e return eder   */
	strcpy(cpath,path);
	strupr(cpath);       /* Byk harfe dntrr  */
	p=strchr(cpath,'\0');
		if(p[1] != '\\'){
			*p ='\\';   /*  Eer yoksa cpath'in sonuna '\' ekler. */
		 *++p = '\0';
		}
	strcpy(_path,cpath);
	strcpy(p,"*.*");
	ret = findfirst(cpath,f_inf,FA_ARCH | FA_HIDDEN | FA_SYSTEM | FA_RDONLY);
		if(ret) /*      hibir trden(dizin hari) dosya bulunmam ise */
		goto SRC_DIR;
	do {
		strcpy(_fname,_path);
		strcat(_fname,f_inf->ff_name);  /*yeni dosya adn yola ekler   */
		_file_ (_fname);        /*      yazdrma fonkiyonu ars      */
		++_nfiles;        /*dosya sayac*/
		} while(!findnext(f_inf));      /*tekrar arama*/
	SRC_DIR:
	/*	dizin arastrma	*/
	ret = findfirst(cpath,f_inf,FA_ARCH | FA_HIDDEN | FA_SYSTEM |
	FA_RDONLY | FA_DIREC);
	if(ret)   goto EXIT;
	do {
			if(f_inf->ff_attrib & FA_DIREC){        /*Dosya tr dizin ise  */
				if(*f_inf->ff_name != '.') {    /*  "."ve ".."adl zel
												 dizinlerin kontrol     */
					strcpy(pbuf,cpath);
					p = strchr(pbuf,'*');
					strcpy(p,f_inf->ff_name);       /*Yeni dizin ad yola
														 ekleniyor       */
					++_ndirs;                     /*        dizin sayac    */
					ftree(pbuf);    		 /* fonksiyon kendini aryor*/
				}
			}
		} while(!findnext(f_inf));
		EXIT:
		/* Bellek yetersizliini nlemek iin bellek boaltma yaplyor  */
		free(f_inf);
		free(cpath);
		free(pbuf);
		return ret;
	}

	void _file_ (char *fname)
	{
		static int olen = 0;
		int i,len;
		len = strlen(fname);
		printf("%s",fname);
		i = olen - len;
		while (i-->0)
			putchar(' ');  /*Bir nce yazlm fazla karakterler silinyor   */
		putchar('\r');
		olen = len;
	}
