       IDENTIFICATION DIVISION.
       PROGRAM-ID.    LIGSETUP.
       SECURITY.      Lig Fikstr Setup Program.
       AUTHOR.        Serkan Uzuner - Eyll'92.
       ENVIRONMENT    DIVISION.
       INPUT-OUTPUT   SECTION.
       FILE-CONTROL.
           COPY LIGFIKS.FLC.
           COPY LIGTAKIM.FLC.
           COPY LIGPARAM.FLC.
       DATA DIVISION.
       FILE SECTION.
           COPY LIGFIKS.LIB.
           COPY LIGTAKIM.LIB.  
           COPY LIGPARAM.LIB.  
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       WORKING-STORAGE SECTION.
       77 YER   PIC 99 VALUE 1.
       77 ESKI  PIC 99 VALUE 0.
       77 KARAR PIC 9  VALUE 0.
       77 KONT-HAFTA-NO  PIC 9(2) VALUE ZEROS.
       77 GECICI-TAKIM   PIC 9(2) VALUE ZEROS.
       77 ENSON-HAFTA-NO PIC 9(2) VALUE ZEROS.
       77 SAKLA-HAFTA-NO PIC 9(2) VALUE ZEROS.
       01 BUGUNUN-TARIHI.
           02 BU-YIL   PIC 99   VALUE 0.
           02 BU-AY    PIC 99   VALUE 0.
           02 BU-GUN   PIC 99   VALUE 0.
       77 LIGDOS-DURUMU PIC XX VALUE SPACES.
      *> Tu Kontrolleri.
       77 ESCKOD PIC 99 VALUE 0.
       77 INTX   PIC 9 COMP-0 VALUE 0.
       77 TUS    PIC 9(4) VALUE 0.
       77 ESC    PIC 9(4) VALUE 6912. 77 SEC    PIC 9(4) VALUE 3328.
       77 F1     PIC 9(4) VALUE 5104. 77 F2     PIC 9(4) VALUE 5360.
       77 F3     PIC 9(4) VALUE 5616. 77 F4     PIC 9(4) VALUE 5872.
       77 F5     PIC 9(4) VALUE 6128.
       77 ASAGI  PIC 9(4) VALUE 0480. 77 YUKARI PIC 9(4) VALUE 8432.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       SCREEN SECTION.
       01 MENU-EKR.
           02 BLANK SCREEN.
           02 LINE 01 COLUMN  1
           "
      -    "".
           02 LINE 02 COLUMN  1
           "
      -    "".
           02 LINE 03 COLUMN  1
           "
      -    "".
           02 LINE 04 COLUMN  1
           "
      -    "".
           02 LINE 05 COLUMN 1
           "
      -    "Ŀ".
           02 LINE 06 COLUMN 1
           "
      -    "/  /   ".
           02 LINE 07 COLUMN 1
           "
      -    "ĳ".
           02 LINE 08 COLUMN 1
           "       Ŀ
      -    "       ".
           02 LINE 09 COLUMN 1
           "                                       
      -    "       ".
           02 LINE 10 COLUMN 1
           "                                       
      -    "       ".
           02 LINE 11 COLUMN 1
           "                                       
      -    "       ".
           02 LINE 12 COLUMN 1
           "                                       
      -    "       ".
           02 LINE 13 COLUMN 1
           "                                       
      -    "       ".
           02 LINE 14 COLUMN 1
           "                                       
      -    "       ".
           02 LINE 15 COLUMN 1
           "                                       
      -    "       ".
           02 LINE 16 COLUMN 1
           "                                       
      -    "       ".
           02 LINE 17 COLUMN 1
           "       
      -    "       ".
           02 LINE 18 COLUMN 1
           "
      -    "ĳ".
           02 LINE 19 COLUMN 1
           "
      -    "       ".
           02 LINE 20 COLUMN 1
           "
      -    "ٰ".
           02 LINE 21 COLUMN  1
           "
      -    "".
           02 LINE 22 COLUMN  1
           "
      -    "".
           02 LINE 23 COLUMN  1
           "
      -    "".
           02 LINE 24 COLUMN  1
           "
      -    "".
           02 LINE 25 COLUMN  1
           "
      -    "".
           02 LINE 19 COLUMN 25
                "   (c) Copyright by SERUZ  - 1992  " HIGHLIGHT.
           02 LINE 07 COLUMN 28 " FUTBOL LG SETUP PROGRAMI " 
              REVERSE-VIDEO.
           02 LINE 06 COLUMN 20 PIC X(30) FROM LIG-ADI HIGHLIGHT.
           02         COLUMN 59 PIC ZZ FROM BU-GUN HIGHLIGHT.
           02         COLUMN 62 PIC ZZ FROM BU-AY  HIGHLIGHT.
           02         COLUMN 65 PIC ZZ FROM BU-YIL HIGHLIGHT.
       01 LIG-AL REVERSE-VIDEO.
           02 LINE 09 COLUMN 37 PIC X(30) USING LIG-ADI.
           02 LINE 11 COLUMN 37 PIC Z USING LIG-GALIBIYET  AUTO.
           02 LINE 12 COLUMN 37 PIC Z USING LIG-MAGLUBIYET AUTO.
           02 LINE 13 COLUMN 37 PIC Z USING LIG-BERABERLIK.
       01 BOS. 02 LINE 00 COLUMN 00 " ".
       01 NORMAL-MENU.
         02 MENU1.
           03 LINE 10 COLUMN 26 "  F1. Lig Dosyalarn Ama      ".
         02 MENU2.
           03 LINE 11 COLUMN 26 "  F2. Lig Ad ve Puanlar       ".
         02 MENU3.
           03 LINE 12 COLUMN 26 "  F3. Takm Girii              ".
         02 MENU4.
           03 LINE 13 COLUMN 26 "  F4. Lig Fikstr Girii       ".
         02 MENU5.
           03 LINE 14 COLUMN 26 "  F5. 2.Yar Fikstr Oluturma ".
         02 MENU6.
           03 LINE 15 COLUMN 26 " Esc. Programdan kma          ".
       01 PARLAK-MENU REVERSE-VIDEO.
         02 MENU-R1.
           03 LINE 10 COLUMN 26 "  F1. Lig Dosyalarn Ama      ".
         02 MENU-R2.
           03 LINE 11 COLUMN 26 "  F2. Lig Ad ve Puanlar       ".
         02 MENU-R3.
           03 LINE 12 COLUMN 26 "  F3. Takm Girii              ".
         02 MENU-R4.
           03 LINE 13 COLUMN 26 "  F4. Lig Fikstr Girii       ".
         02 MENU-R5.
           03 LINE 14 COLUMN 26 "  F5. 2.Yar Fikstr Oluturma ".
         02 MENU-R6.
           03 LINE 15 COLUMN 26 " Esc. Programdan kma          ".
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       PROCEDURE DIVISION.
       BASLA.
           PERFORM LIG-VE-TARIHI-AL.
           DISPLAY MENU-EKR NORMAL-MENU.
           PERFORM KONTROL.
       CEVAP-AL. DISPLAY BOS.
           CALL X"83" USING INTX. MOVE INTX TO TUS.
           EVALUATE TUS
                WHEN ESC DISPLAY (1,1) ERASE STOP RUN
                WHEN SEC PERFORM GONDER GO BASLA
                WHEN F1  PERFORM DOSYA-ACMA GO BASLA
                WHEN F2  PERFORM LIG-OKU THRU LIG-SON GO BASLA
                WHEN F3  CALL "LIGTAKIM" CANCEL "LIGTAKIM"  GO BASLA
                WHEN F4  CALL "LIGFIKSG" CANCEL "LIGFIKSG"  GO BASLA
                WHEN F5  PERFORM 2YARI-BASI THRU 2YARI-SONU GO BASLA
                WHEN ASAGI  MOVE YER TO ESKI
                     IF YER=6 MOVE 1 TO YER 
                         ELSE ADD  1 TO YER
                     END-IF PERFORM KONTROL
                WHEN YUKARI MOVE YER TO ESKI
                     IF YER=1 MOVE 6 TO YER
                         ELSE SUBTRACT 1 FROM YER
                     END-IF PERFORM KONTROL
           END-EVALUATE
           GO CEVAP-AL.
       GONDER.
           EVALUATE YER WHEN 1 PERFORM DOSYA-ACMA
                        WHEN 2 PERFORM LIG-OKU THRU LIG-SON
                        WHEN 3 CALL "LIGTAKIM" CANCEL "LIGTAKIM"
                        WHEN 4 CALL "LIGFIKSG" CANCEL "LIGFIKSG"
                        WHEN 5 PERFORM 2YARI-BASI THRU 2YARI-SONU
                        WHEN 6 DISPLAY (1,1) ERASE STOP RUN.
       KONTROL.
           EVALUATE ESKI WHEN 1 DISPLAY MENU1
                         WHEN 2 DISPLAY MENU2
                         WHEN 3 DISPLAY MENU3
                         WHEN 4 DISPLAY MENU4
                         WHEN 5 DISPLAY MENU5
                         WHEN 6 DISPLAY MENU6.
           EVALUATE YER  WHEN 1 DISPLAY MENU-R1
                         WHEN 2 DISPLAY MENU-R2
                         WHEN 3 DISPLAY MENU-R3
                         WHEN 4 DISPLAY MENU-R4
                         WHEN 5 DISPLAY MENU-R5
                         WHEN 6 DISPLAY MENU-R6.
       LIG-VE-TARIHI-AL.
           ACCEPT BUGUNUN-TARIHI FROM DATE.
           OPEN INPUT LIGDOS.
           IF LIGDOS-DURUMU="00" READ LIGDOS
              ELSE MOVE SPACES TO LIG-ADI.
           CLOSE LIGDOS.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * *                      Lig Dosyalarn Ama                     * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       DOSYA-ACMA.
           DISPLAY (1,1) ERASE.
           DISPLAY '~L=LIGMENU/'.
           DISPLAY '~W=DOSYAAC,NOESC/'.
           ACCEPT (2,2) KARAR WITH AUTO-SKIP. DISPLAY (2,2) "".
           IF KARAR=1 OPEN OUTPUT TAKIMDOS CLOSE TAKIMDOS GO DOSYA-ACMA.
           IF KARAR=2 OPEN OUTPUT FIKSDOS  CLOSE FIKSDOS  GO DOSYA-ACMA.
           DISPLAY '~C=ALL/'.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * *                       Ligin Adn Girme                       * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       LIG-OKU.
           DISPLAY (1,1) ERASE.
           DISPLAY '~L=LIGMENU/'.
           DISPLAY '~W=LIGOKU,NOESC,NOMOVE,NOWAIT/'.
           OPEN INPUT LIGDOS.
           IF LIGDOS-DURUMU NOT="00" MOVE SPACES TO LIG-ADI
                                     MOVE 3 TO LIG-GALIBIYET
                                     MOVE 0 TO LIG-MAGLUBIYET
                                     MOVE 1 TO LIG-BERABERLIK.
           CLOSE LIGDOS.
           DISPLAY LIG-AL.
       LIG-ADI-OKU.
           ACCEPT LIG-AL. ACCEPT ESCKOD FROM ESCAPE KEY.
           IF ESCKOD=01 GO LIG-SON. IF ESCKOD NOT=00 GO LIG-ADI-OKU.
           OPEN OUTPUT LIGDOS.
           WRITE LIG-KAYDI INVALID DISPLAY (2,2) "".
           CLOSE LIGDOS.
       LIG-SON.
           DISPLAY '~C=ALL/'.
           EXIT.
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* * * *                    2.Yar Fikstrn Oluturma                * * * *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
       2YARI-BASI.
           DISPLAY (1,1) ERASE.
           DISPLAY '~L=LIGMENU/'.
           DISPLAY '~W=IKINCI,NOESC/'.
           ACCEPT (2,2) KARAR WITH AUTO-SKIP. DISPLAY (2,2) " ".
           IF KARAR=2 GO 2YARI-SONU.
           DISPLAY '~W=2YARI,NOWAIT/'.
       SON-HAFTA-NO.
           MOVE ZEROS TO ENSON-HAFTA-NO.
           MOVE 99    TO FIKS-HAFTA-NO FIKS-MAC-NO.
           OPEN INPUT FIKSDOS.
           START FIKSDOS KEY LESS THAN FIKS-KEY
                            INVALID GO SON-HAFTA-SONU.
       SON-HAFTA-OKU.
           READ FIKSDOS NEXT AT END GO SON-HAFTA-SONU.
           MOVE FIKS-HAFTA-NO TO ENSON-HAFTA-NO.
       SON-HAFTA-SONU.
           MOVE 0 TO SAKLA-HAFTA-NO.
           COMPUTE KONT-HAFTA-NO=ENSON-HAFTA-NO + 1.
           CLOSE FIKSDOS.
           OPEN I-O FIKSDOS.
       2YARI-OKU.
           READ FIKSDOS NEXT AT END CLOSE FIKSDOS GO 2YARI-SONU.
           IF FIKS-HAFTA-NO=KONT-HAFTA-NO CLOSE FIKSDOS GO 2YARI-SONU.
           IF FIKS-HAFTA-NO NOT=SAKLA-HAFTA-NO
                            ADD 1 TO ENSON-HAFTA-NO
                            MOVE FIKS-HAFTA-NO TO SAKLA-HAFTA-NO.
           MOVE ENSON-HAFTA-NO TO FIKS-HAFTA-NO.
           MOVE FIKS-TAKIM2  TO GECICI-TAKIM.
           MOVE FIKS-TAKIM1  TO FIKS-TAKIM2.
           MOVE GECICI-TAKIM TO FIKS-TAKIM1.
           MOVE ZEROS        TO FIKS-SONUC1 FIKS-SONUC2 FIKS-TEST.
           WRITE FIKSTUR-KAYDI INVALID DISPLAY (2,2) "*".
           GO 2YARI-OKU.
       2YARI-SONU.
           DISPLAY '~C=ALL/'.
           EXIT.
